* =======================================================================
* DISS_ASM.
*
* This file is included by QLTdis_asm and is used to define the main
* disassembly and printing routines. 
* initialisation and each loop initialisation are defined in this file.
* This file may be further sub-divided as each routine for the various
* instruction types are coded - this depends upon the size of said 
* routines.
* =======================================================================



* =======================================================================
* Disassembly routine(s) :
* =======================================================================
* 1. Save current address (start of the new instruction)
* 2. Decode current word - and any subsequent words of data etc
* 3. Fill buffers etc
*
* Returns Z set if any errors.
* =======================================================================
diss        moveq    #0,d0                    ; No errors
            rts


* =======================================================================
* Print routine(s)
* =======================================================================
* 1. Print current address
* 2. Print hex data
* 3. print instruction
*
* Returns Z set if no errors.
* =======================================================================
print       moveq    #0,d0                    ; No errors
            rts
