100 REMark AGMellipse_bas
110 REMark H L Schaaf Aug 7, 1998
120 REMark to accompany Gee Graphics part 6 in QLToday
130 :
140 WTV : PAPER 0 : INK 7 : CLS : menu
150 :
160 DEFine PROCedure calc_n_show
170 REPeat queries
180 CLS  :  CLS#0
190 INPUT \,"Perimeter of Ellipse ? (more than zero, less than 1E308) ";p
200 CLS#0
210 IF p<=0 OR p > 1E308 THEN
220  PRINT#0;p;" out of range, use a positive value less than 1E308"
230  GO TO 190
240 END IF
250 SCALE p/2,-p/3,-p/4
260 CLS
270 PRINT\ "the perimeter is given as ";p
280 PRINT\ "e = Eccentricity can range from 0 to 1 (also called k)"
290 PRINT\ "d = equivalent angle from 0 to 90 degrees  { == ASIN(e) }"
300 radius = p/(2*PI)
310 PRINT\\ "a = semi-major axis can be from ";radius;" to ";p/4
320 PRINT\ "b = semi-minor axis can be from 0 to ";radius
330 INPUT\ "which one of these will be given; e OR d OR a OR b ?",ans$
340 IF ans$ == 'a' : find_be
350 IF ans$ == 'b' : find_ae
360 IF ans$ == 'd' : convert_d_to_e
370 got_e = 0
380 IF ans$ == 'e' : find_ab
390 IF NOT((ans$=='a')OR(ans$=='b')OR(ans$=='d')OR(ans$=='e')) : GO TO 260
400 CLS : CLS#0
410 :
420 give_answer
430 PRINT #0,,"touch [spacebar] for illustration"
440 PAUSE
450 CLS: CLS#0
460 draw_ellipse a,b
470 PRINT #0,,"touch [spacebar] for another ellipse, [ESC] for menu."
480 IF CODE(INKEY$(-1))=27 : CLS#0 : menu
490 END  REPeat queries
500 END DEFine  calc_n_show
510 :
520 DEFine PROCedure convert_d_to_e
530 INPUT\ "Degrees of inclination 'd' ? ",d
540 CLS #0
550 IF d<0 OR d>90 : PRINT #0;d;' out of range (0 to 90)' : GO TO 530
560 IF d >= 89.998 : d=90
570 e = SIN(RAD(d))
580 got_e = 1
590 find_ab
600 END DEFine convert_d_to_e
610 :
620 DEFine PROCedure find_ab
630 REMark given e, find a, and b
640 REMark e = (SQRT(a^2 - b^2))/a
650 IF NOT got_e : INPUT\ "Eccentricity 'e' ?", e
660 CLS#0
670 IF e <0 OR e>1 THEN
680  PRINT #0;e;" out of range (0 to 1)" : got_e = 0 : GO TO 650
690 END IF
700 REMark assume a = radius, calculate b, get p1 and compare with p
710 a = 1
720 b = SQRT((a*a) - (a*e)*(a*e))
730 d1 = DEG(ASIN(e))
740 p1 = PerimEllip(a,b)
750 REMark modify to fit
760 a = a * (p/p1)
770 b = SQRT((a*a) - (a*e)*(a*e))
780 p1 = PerimEllip(a,b)
790 END DEFine find_ab
800 :
810 DEFine PROCedure give_answer
820 CLS
830 INK 4
840 PRINT\ "eccentricity"; TO 14;"semi-major"; TO 26;"semi-minor";
850 PRINT TO 38;"perimeter" TO 50;"error"
860 PRINT e; TO 14; a; TO 26; b; TO 38; p1; TO 50; p-p1
870 PRINT\ "major axis = ";2*a,", minor axis = ";2*b
880 PRINT "F(k) AGM ( 1st complete elliptic) = ";
890 PRINT AGM_ellipint(SIN(RAD(d1)))
900 PRINT "E(k) AGM ( 2nd complete elliptic) = "; E_k
910 PRINT "major circum = ";2*a*PI,"minor circum = ";2*b*PI
920 PRINT "k = ASIN(e) = ";DEG(ASIN(e));""
930 INK 7
940 END DEFine give_answer
950 :
960 DEFine PROCedure find_be
970 REMark given a, find b and e
980 INPUT\ "Semi-major axis 'a' ?",a
990 CLS#0
1000 IF a < radius OR a > p/4 THEN
1010  PRINT#0;a;" out of range (";radius;" to ";p/4;")" : GO TO 980
1020 END IF
1030 REMark set b = a and then find p1
1040 b = a
1050 REMark adjust b until p == p1
1060 REPeat loop
1070 p1 = PerimEllip(a,b)
1080 IF p == p1 : EXIT loop
1090 b = b * (p/p1)
1100 END REPeat loop
1110 e = ecc(a,b)
1120 d1=DEG(ASIN(e))
1130 END DEFine find_be
1140 :
1150 DEFine PROCedure find_ae
1160 REMark given b, find a and e
1170 INPUT\ "Semi-minor axis 'b' ?",b
1180 CLS#0
1190 IF b < 0 OR b > radius THEN
1200  PRINT#0;b;" out of range (0 to ";radius;")"  : GO TO 1170
1210 END IF
1220 a = b
1230 REMark assume a = b (smaller circle) and then find p1
1240 REMark adjust a until p = p1
1250 REPeat loop
1260  p1 = PerimEllip(a,b)
1270  IF p == p1 : EXIT loop
1280  a = a * (p/p1)
1290 END REPeat loop
1300 e = ecc(a,b)
1310 d1=DEG(ASIN(e))
1320 END DEFine find_ae
1330 :
1340 DEFine FuNction PerimEllip(a,b)
1350 K_k = AGM_ellipint(ecc(a,b))
1360 RETurn 4*a*E_k
1370 END DEFine PerimEllip
1380 :
1390 DEFine FuNction ecc(a,b)
1400 RETurn (SQRT(a*a - b*b))/a
1410 END DEFine ecc
1420 :
1430 DEFine PROCedure draw_ellipse(a,b)
1440 LOCal i
1450 REMark red circle for major axis
1460 INK 2
1470 CIRCLE 0,0,a
1480 REMark green circle for minor axis
1490 INK 4
1500 CIRCLE 0,0,b
1510 REMark now the ellipse plotted at every degree in white
1520 INK 7
1530 FOR i = 0 TO 2*PI STEP PI/180
1540  x = a*COS(i)
1550  y = b*SIN(i)
1560  POINT x,y
1570 END FOR i
1580 END DEFine draw_ellipse
1590 :
1600 DEFine FuNction AGM_ellipint(k)
1610 LOCal i
1620 REMark Arithmetic geometric mean for elliptic integrals based on
1630 REMark Algorithm 1.2 in "Pi and the AGM" by Borwein and Borwein
1640 REMark    ISBN 0-471-83138-7   John Wiley 1987
1650 REMark solves F(k) = complete elliptic integral of first kind
1660 REMark   and  E(k) = complete elliptic integral of second kind
1670 REMark k is the eccentricity of the ellipse
1680 REMark k is often expressed in terms of alpha = ASIN(k)
1690 REMark k' is the complementary k
1700 IF k<0 OR k>1 : PRINT #0;k;' is out of range (0 to 1)':STOP
1710 k_comp = SQRT(1-k*k)
1720 REMark iter(1 for Arithmetic, Borwein's 'a'
1730 REMark iter(2 for Geometric,  Borwein's 'b'
1740 REMark iter(3 for Borwein's 'c', a measure of convergence
1750 DIM iter(3,1)
1760 iter(1,0) = 1
1770 iter(2,0) = k_comp
1780 iter(3,0) = k
1790 sum_of_terms = (2^-1)*(k*k)
1800 nth = 0
1810 REPeat converge
1820  iter(1,1) = (iter(1,0)+iter(2,0))/2
1830  iter(2,1) = SQRT((iter(1,0)*iter(2,0)))
1840  iter(3,1) = iter(1,0)-iter(1,1)
1850  sum_of_terms = sum_of_terms + 2^(nth)*(iter(3,1)*(iter(3,1)))
1860  nth = nth + 1
1870  FOR i = 1 TO 3
1880   iter(i,0)=iter(i,1)
1890  END FOR i
1900  IF ( iter(3,0) < 1E-10 ) : EXIT converge
1910 END REPeat converge
1920 REMark ratio of second kind to first kind
1930 sec_to_first = 1 - sum_of_terms
1940 K_k = PI/(2*iter(1,1))
1950 E_k = K_k * sec_to_first
1960 IF k = 1 THEN
1970  REMark K_k is actually infinity
1980  K_k = 9.9E615 : E_k = 1
1990 END IF
2000 RETurn K_k
2010 RETurn E_k
2020 END DEFine AGM_ellipint
2030 :
2040 DEFine PROCedure same_perim
2050 p  = 100
2060 SCALE p/2,-p/3,-p/4
2070 CLS
2080 FOR e = 0 TO .6 STEP .1 , .61 TO .95 STEP 1E-2
2090 got_e = 1
2100 find_ab
2110 CLS
2120 ELLIPSE 0, 0, b, a/b, 0
2130 END FOR e
2140 FOR e = .951 TO .99 STEP 1E-3,.991 TO 1 STEP 1E-4
2150 find_ab
2160 IF NOT(b) :  EXIT e
2170 IF b: CLS : ELLIPSE 0, 0, b, a/b, 0
2180 END FOR e
2190 CLS :LINE -p/4,0 TO p/4,0
2200 PRINT #0,,,,,"[spacebar] for menu"
2210 PAUSE
2220 menu
2230 END  DEFine same_perim
2240 :
2250 DEFine  PROCedure same_area
2260 REMark start with circle
2270 REMark equal area ellipses
2280 SCALE 4,-3,-2
2290 CLS
2300 prod = .25
2310 FOR b = .5 TO 9E-2 STEP -1E-3
2320 IF b : a = prod/b
2330 CLS
2340 IF b: ELLIPSE 0,0,b,a/b,0
2350 END FOR b
2360 PRINT #0,,,,,"[spacebar] for menu"
2370 PAUSE
2380 menu
2390 END  DEFine same_area
2400 :
2410 DEFine PROCedure  menu
2420 CLS :CLS#0
2430 PRINT\\"  This program can calculate complete elliptic integrals"
2440 PRINT,"of the first and second kind."
2450 PRINT\,'If given a perimeter and one of the following:'
2460 PRINT,'  ( major axis OR minor axis OR eccentricity )'
2470 PRINT,'it will return the other values and draw the ellipse.'
2480 PRINT\,'It can also show a series of ellipses from circle to line;'
2490 PRINT,'all having either the same perimeter, or the same area.'
2500 PRINT\'  Select by touching number key.'
2510 PRINT \,'[ 1 ]  Calculate Parameters and Show Ellipse'
2520 PRINT \,'[ 2 ]  Constant Perimeter Ellipses'
2530 PRINT \,'[ 3 ]  Constant Area Ellipses'
2540 PRINT \,'[ 4 ]  QUIT'
2550 a$=INKEY$(-1)
2560 choice = a$
2570 SELect ON choice
2580  = 1 : calc_n_show
2590  = 2 : same_perim
2600  = 3 : same_area
2610  = 4 : CLS : STOP
2620  = REMAINDER  : menu
2630 END SELect
2640 END  DEFine menu
2650 :
2660 REMark end of listing for AGMellipse_bas
