100 REMark Tetrahedron_bas
110 REMark H L Schaaf December 9,  1998
120 REMark to go with Gee Graphics #8 in QL Today
130 :
140 initialize  : draw_solid t_f_v%  : transforms_demo
150 :
160 DEFine PROCedure initialize
170  set_screen : set_inks
180  read_vertex_data : make_face_vertex_list
190  find_face_centers :  sort_face_zs
200 END DEFine initialize
210 :
220 DEFine PROCedure transforms_demo
230  REPeat demo_loop
240   transform_menu
250   IF  ans$=="q" :EXIT demo_loop
260   CLS : draw_solid t_f_v%
270   PRINT #0;  "[space bar] for  menu" : PAUSE
280  END REPeat  demo_loop
290  INK 7
300 END DEFine transforms_demo
310 :
320 DEFine PROCedure set_screen
330  graspix  = 1/2
340  IF VER$ == "JSU" THEN graspix  = 344/549
350  IF ((VER$ == "HBA") OR (VER$ == "JSL1")) THEN graspix  = 476/645
360  IF graspix  == 1/2 THEN PRINT  "What ROM are you using ?":PAUSE
370  WINDOW 512, 200, 0, 0 : PAPER 0 : INK 7 : MODE 4
380  WINDOW #0, 512, 56, 0, 200 : PAPER #0, 0 : INK #0, 4 : CLS #0
390  horz_to_vert = 512/200 : REMark the window size in pixels
400  vert_scale = 4
410  horz_width = (vert_scale / (200-1)) * (512-1) * graspix
420  SCALE vert_scale, -horz_width/2, -vert_scale/2
430  CLS
440 END  DEFine set_screen
450 :
460 DEFine PROCedure read_vertex_data
470  RESTORE 560
480  DIM t_v(4,3)
490  FOR i  =  1 TO DIMN(t_v)
500   FOR  j = 1 TO  3
510    READ t_v(i,j)
520   END  FOR j
530  END  FOR i
540 END DEFine read_vertex_data
550 :
560 REMark Original DATA set for tetrahedron from Coxeter
570 DATA   1,   1,   1
580 DATA   1,  -1,  -1
590 DATA  -1,   1,  -1
600 DATA  -1,  -1,   1
610 :
620 DEFine PROCedure transform_menu
630  CLS #0
640  PRINT #0;"[T]ranslation, [R]otation, [S]caling, ";
650  PRINT #0;"[O]riginal data, [A]nimation or [Q]uit ?"
660  ans$=INKEY$(-1)
670  ans_num  = CODE(ans$)MOD 32
680  SELect ON ans_num
690   =  1 : motion$ = "Spin around " :spin_around
700   = 15 : initialize
710   = 17 : CLS #0 : RETurn
720   = 18 : get_variables : rotate t_v, axis_num, amount
730   = 20 : get_variables : translate t_v, axis_num, amount
740   = 19 : zoom t_v
750   =  REMAINDER : GO TO  660
760  END  SELect
770 END  DEFine transform_menu
780 :
790 DEFine PROCedure get_variables
800  IF ans_num = 18 : motion$="Rotation about "
810  IF ans_num = 18 : measure$=" degrees "
820  IF ans_num = 20 : motion$="Translation along "
830  IF ans_num = 20 : measure$=" amount "
840  get_axis
850  INPUT #0;"ENTER "&measure$&" of "&motion$&ans$&" axis",amount
860 END DEFine get_variables
870 :
880 DEFine PROCedure get_axis
890  PRINT #0; motion$; "which axis;  [x], [y], or [z] ?"
900  ans$  =  INKEY$(-1)
910  axis_num =  (CODE(ans$) MOD 32 ) - 23
920  IF (( axis_num < 1 ) OR ( axis_num > 3 )) : CLS #0 : GO TO 890
930 END DEFine  get_axis
940 :
950 DEFine PROCedure translate(array, axis_num, shift_amount)
960  FOR  i = 1 TO DIMN(array)
970   array(i,axis_num) = array(i,axis_num) + shift_amount
980  END FOR i
990  find_face_centers : sort_face_zs
1000 END DEFine translate
1010 :
1020 DEFine  PROCedure  rotate(array,axis_num,turn_amount)
1030  DIM temp(3)
1040  rot_r = - RAD(turn_amount)
1050  sumin = (axis_num MOD 3) + 1
1060  difin =  (sumin MOD 3 ) + 1
1070  cos_r = COS(rot_r) :  sin_r = SIN(rot_r)
1080  FOR  i  = 1 TO  DIMN(array)
1090   temp(axis_num) =  array(i,axis_num)
1100   temp(sumin)=array(i,sumin)*cos_r + array(i,difin)*sin_r
1110   temp(difin)=array(i,difin)*cos_r - array(i,sumin)*sin_r
1120   FOR  j  = 1  TO  3
1130    array(i,j)  =  temp(j)
1140   END  FOR  j
1150  END  FOR i
1160  find_face_centers : sort_face_zs
1170 END DEFine  rotate
1180 :
1190 DEFine  PROCedure  zoom(array)
1200  CLS#0
1210  INPUT#0;"Enter Scaling factor",zoom_fac
1220  FOR  i = 1  TO  DIMN(array)
1230   FOR j  =  1 TO  3
1240    array(i,j)=array(i,j) *  zoom_fac
1250   END  FOR j
1260  END FOR i
1270  find_face_centers : sort_face_zs
1280 END  DEFine zoom
1290 :
1300 DEFine PROCedure make_face_vertex_list
1310  DIM t_f_v%(4,3)
1320 REMark  4 faces, 3 vertices each
1330  RESTORE  1350
1340 REMark vertices ordered for counter-clockwise closure
1350  DATA 3,2,1,  1,2,4, 4,3,1, 4,3,2
1360  FOR i = 1 TO DIMN(t_f_v%)
1370   FOR j = 1 TO 3
1380    READ t_f_v%(i,j)
1390   END FOR j
1400  END FOR i
1410 END DEFine make_face_vertex_list
1420 :
1430 DEFine PROCedure find_face_centers
1440  DIM t_f_c(4,3)
1450 REMark to hold the x,y,z values for face centers
1460 REMark and to determine order for drawing each face
1470 REMark for each face
1480  FOR i =  1 TO 4
1490   DIM sumxyz(3)
1500 REMark and for each vertex in that face
1510   FOR j = 1 TO 3
1520 REMark and for each of the coordinates
1530    FOR k = 1 TO 3
1540 REMark add them together
1550     sumxyz(k) = sumxyz(k)  + t_v(t_f_v%(i,j),k)
1560    END  FOR k
1570   END  FOR  j
1580 REMark then take the average of the three values
1590   FOR k = 1 TO 3
1600    t_f_c(i,k)=sumxyz(k)/3
1610   END FOR k
1620  END FOR i
1630 END DEFine find_face_centers
1640 :
1650 DEFine PROCedure  set_inks
1660  DIM nks(4)
1670 REMark use 4 colors, one per face
1680  RESTORE  1690
1690  DATA   2,    4,     7,    242
1700 REMark red, green, white, gold
1710  FOR i = 1 TO 4
1720   READ nks(i)
1730  END  FOR i
1740 END DEFine set_inks
1750 :
1760 DEFine PROCedure sort_face_zs
1770 REMark  arrange faces by z-value of face-centers
1780 REMark put t_f_c(i,3)'s in order, showing most positive first
1790 REMark create index array of pointers for sorting z values
1800  DIM zsort(4) : FOR i = 1 TO 4 :  zsort(i) = i : END FOR i
1810  REPeat short_sort
1820   swaps = 0
1830   FOR i = 2 TO 4
1840    IF t_f_c(zsort(i-1),3)<t_f_c(zsort(i),3) THEN
1850     swaps  =  swaps  +  1
1860     swap zsort(i-1) , zsort(i)
1870    END IF
1880   END FOR i
1890   IF NOT(swaps) : EXIT short_sort
1900  END REPeat short_sort
1910 END DEFine sort_face_zs
1920 :
1930 DEFine PROCedure draw_solid(f_v_array)
1940 REMark at least one face (the most distant) will always  be hidden
1950  FOR i = 2 TO DIMN(f_v_array)
1960   ii  = zsort(i) : INK nks(ii) : FILL 1
1970   POINT t_v(f_v_array(ii,3),1) ,t_v(f_v_array(ii,3),2)
1980   FOR j = 1 TO 3
1990    LINE TO t_v(f_v_array(ii,j),1) ,t_v(f_v_array(ii,j),2)
2000   END  FOR j
2010   FILL  0
2020  END FOR i
2030 END  DEFine draw_solid
2040 :
2050 DEFine PROCedure swap (n1, n2)
2060  n1 = n1 + n2 : n2 = n1 - n2 : n1 = n1 - n2
2070 END  DEFine swap
2080 :
2090 DEFine PROCedure spin_around
2100  CLS#0
2110  get_axis
2120  INPUT#0;"ENTER Degrees per frame of animation ?",frame_shift
2130  CLS #0
2140  PRINT #0; frame_shift; CHR$(186);
2150  PRINT #0;" per frame around the ";ans$;"  axis",
2160  PRINT#0;"[ESC] to stop"
2170  REPeat spin_loop
2180   rotate t_v,axis_num,frame_shift
2190   CLS
2200   draw_solid t_f_v%
2210 REMark change the INKEY$ value for display time per frame
2220   IF INKEY$(8) == CHR$(27) : EXIT spin_loop
2230  END REPeat spin_loop
2240 END DEFine spin_around
2250 :
2260 REMark end of listing Tetrahedron_bas
