100 REMark Fit9c5_bas
110 REMark Ultimate objective is to display (in motion) the
120 REMark Five Intersecting Tetrahedra like the modular origami ?
130 REMark H. L. Schaaf  Dec 8, 1996
140 REMark revisions Feb 14th, 1999 for QL Today cover disk(?)
150 REMark and description in QL Today GG#9
160 :
170 REMark problems @ 
180 RESTORE  10410  : REMark needed to declare array before calling it !
190 REMark for OUTLINE of this program list following RESTORE# lines
200 RESTORE 27360 : RESTORE 28800   : REMark outline, etc.
210 RESTORE 28880 : REMark last line - limit is 32767 ! ? !
220 :
230 set_screen
240 set_constants
250 build_solids
260 INK 4
270 CLS #0 :PRINT #0; "Program has finished "
280 STOP
290 :
300 DEFine PROCedure build_solids
310 REMark these have a lot in common, is a general procedure possible ?
320 build_tetrahedron
330 build_cube
340 build_octahedron
350 build_dodecahedron
360 build_icosahedron
370 REMark build_FIT
380 END DEFine build_solids
390 :
400 DEFine PROCedure set_screen
410 LOCal i,j
420 WTV
430 MODE 4
440 WINDOW #0,512,20,0,236
450 CLS #0
460 WINDOW 512,236,0,0
470 CSIZE 0,0
480 SCALE 4,-3,-2
490 PAPER 0 : INK 4
500 OVER 0 : FILL 0
510 CLS
520 REMark 10 colors
530 DIM FIT_color(5,2)
540 RESTORE 26000
550 FOR i = 1 TO 2
560   FOR j = 1 TO 5
570     READ FIT_color(j,i)
580   END FOR j
590 END FOR i
600 REMark 21 colors ( black doesn't count )
610 DIM ink4(21)
620 RESTORE 26000
630 FOR i = 1 TO 21
640   READ ink4(i)
650 END FOR i
660 END DEFine set_screen
670 :
680 DEFine PROCedure set_constants
690 LOCal i,j
700 REMark begin constants & variables list
710 xyz = 3  : REMark for loops that are picking up 3D coordinates
720 tau  = (SQRT(5)+1)/2  : REMark Golden Ratio     1.618... phi?
730 itau = 1/tau          : REMark inverse of tau   0.618...
740 kappa = .5 * ACOS(1/3)
750 lambda = .5 * ATAN(2)
760 mu = .5 * ASIN(2/3)
770 strut_width = .25
780 REMark 1/4 seems to be a 'snug but loose'? fit for the FIT
790 REMark strut width (1/4) as ratio to distance from vertex to center of face
800 REMark probably should have this as a make_struts parameter variable
810 :
820 CLS
830 PRINT "Kappa =  ";:show_DMS kappa
840 PRINT "Lambda = ";:show_DMS lambda
850 PRINT "Mu =     ";:show_DMS mu
860 PAUSE 60
870 :
880 REMark Name Strings
890 DIM PS_name$(6,12)
900 RESTORE 25430
910 FOR i = 1 TO 6
920   READ PS_name$(i)
930 END FOR i
940 :
950 REMark numbers of vertices, edges, faces, edges/face, edges/vertex
960 DIM PS_vefpq%(6,5)
970 RESTORE 25520
980 FOR i = 1 TO 6
990  FOR j = 1 TO 5
1000   READ PS_vefpq%(i,j)
1010  END FOR j
1020 END FOR i
1030 :
1040 REMark PS_radii(n,[1, 2, 3]) 1=inner, 2=mid, 3=circumscribing
1050 REMark inner touches center of faces
1060 REMark middle touches center of edges
1070 REMark outer touches vertices
1080 REMark based on edge length of 2
1090 DIM PS_radii(6,3)
1100 RESTORE 25630
1110 FOR i = 1 TO 6
1120  PS_radii(i,0) = 1
1130  FOR j = 1 TO 3
1140   READ PS_radii(i,j)
1150   REMark convert to edge length of 1
1160   PS_radii(i,j) = PS_radii(i,j)/2
1170  END FOR j
1180 END FOR i
1190 :
1200 REMark PS_angles(6,3) dihedral(0) and spherical[1 to 3] ?
1210 REMark [1 to 3] = phi, chi, psi in Coxeter.
1220 DIM PS_angles(6,3)
1230 RESTORE 25750
1240 FOR i = 1 TO 6
1250  FOR j = 1 TO 3
1260   READ PS_angles(i,j)
1270  END FOR j
1280  PS_angles(i,0) = PI - 2*PS_angles(i,3)
1290 END FOR i
1300 :
1310 show_angles
1320 :
1330 set = 0 : tet = 0 : REMark declare  _before_ calling!
1340 PAUSE 30
1350 END DEFine set_constants
1360 :
1370 REMark tetrahedron
1380 DEFine PROCedure build_tetrahedron
1390 PS = 1
1400 get_PS_nums(PS)
1410 REMark vertices and links
1420 DIM t_v(vertices,xyz)
1430 DIM t_vf%(vertices,q)
1440 DIM t_ve%(vertices,q)
1450 REMark edge links
1460 DIM t_ev%(edges,2)
1470 DIM t_ef%(edges,2)
1480 REMark face links and equations and centers
1490 DIM t_fv%(faces,p)
1500 DIM t_fe%(faces,p)
1510 DIM t_fq(faces,10)
1520 tl = 2 * SQRT(2)
1530 REMark tl is length of edge of tetrahedron
1540 RESTORE 22970 : REMark or next line's RESTORE value
1550 RESTORE 23040
1560 get_vertices t_v
1570 INK ink4(PS) :  CLS :CLS#0
1580 show_vertices t_v
1590 PRINT#0; "have vertices for ";PS_name$(PS)
1600 get_edges t_ev%,t_v,tl
1610 show_edges t_ev%,t_v
1620 PRINT#0; "have edges for ";PS_name$(PS)
1630 get_vertex_to_edges t_ve%,t_v,t_ev%
1640 PRINT#0; "have Vertex to edges for ";PS_name$(PS)
1650 get_faces t_fv%, t_fe%, t_ef%, t_vf%, t_v, t_ev%, t_ve%, t_fq
1660 PRINT #0; "Faces gathered for ";PS_name$(PS)
1670 REMark  review_links PS,t_v,t_ve%,t_vf%,t_ev%,t_ef%,t_fv%,t_fe%,t_fq
1680 CLS#0
1690 PRINT #0;"revolving wire-frame for ";PS_name$(PS)
1700 revolve t_ev% , t_v
1710 REMark adjust t_ev% , t_v
1720 CLS : CLS#0
1730 PRINT #0;"showing faces for ";PS_name$(PS)
1740 show_faces t_fv%, t_v, t_fq
1750 :
1760 turn_faces PS, t_fv%, t_v, t_fq
1770 :
1780 REMark build struts, 2 trapezoids each with common original edge
1790 REMark 4 outside vertices,+ 4 faces with 3 inside vertices per face
1800 DIM t_sv(vertices+faces*p,xyz)
1810 REMark strut vertices
1820 REMark  = 16 vertices (4 original outer + 12 new inner)
1830 REMark 6 struts corresponding to original edges,
1840 DIM t_sev%(edges+faces*2*p,2)
1850 REMark strut edge to vertices pointers
1860 REMark 6 original edges +( 4 faces *2 edges * 3 vertices/face)
1870 REMark an edge from vertex towards center radially
1880 REMark and a chord from there to adjacent inside vertex.
1890 REMark 30 edges (6 original + 24 new )
1900 REMark make strut-trapezoids "strutz"
1910 make_struts t_v,t_fq,t_ev%,t_fv%,t_sv,t_sev%
1920 CLS#0
1930 PRINT #0;"revolving wire-frame ";PS_name$(PS);" with struts"
1940 revolve t_sev% , t_sv
1950 REMark adjust t_sev% , t_sv
1960 :
1970 DIM t_s%(edges,2,8)
1980 REMark 2 trapezoids adjacent to each edge
1990 REMark [0-8]; 0 = face#,
2000 REMark 1 to 4 = vertices 1 to 4
2010 REMark as pointers to t_sv
2020 REMark 5 = edge , 6 = radial, 7 = chord , 8 = radial
2030 REMark as pointers to t_sev%
2040 REMark vertices and edges will be ordered
2050 REMark polygons
2060 DIM t_p(edges*2,2,xyz)
2070 REMark p,0,0 as ?
2080 REMark p,1,0 as pointer to edge owner
2090 REMark p,2,0 as pointer to face owner
2100 REMark p,0,xyz center of polygon
2110 REMark p,1,xyz minimum values
2120 REMark p,2,xyz maximum values
2130 DIM t_tagz%(edges*2-1)
2140 DIM t_z(edges*2-1)
2150 REMark to aid in sorting polygons
2160 CLS
2170 make_polys t_s%,t_ef%,t_sv,t_sev%,t_p,t_z
2180 I_FILL t_tagz%,0,1
2190 SORT t_z,1,t_tagz%
2200 show_polys t_tagz%,t_p,t_s%,t_sv,t_sev%
2210 turn_polyz t_p,t_fq,t_s%,t_sv
2220 END DEFine build_tetrahedron
2230 :
2240 DEFine PROCedure turn_polyz (pa,fqa,sa,sva)
2250 LOCal i,j,ii
2260 poly_copy
2270  CLS#0
2280 PRINT #0;"turning polygons of ";PS_name$(PS);" with struts ";
2290 IF ( set AND tet ): PRINT #0;" set ";set!!"tet ";tet
2300 center_bounds
2310 zorder
2320 show_polyz
2330 REMark FOR ii = 1 TO 32
2340 FOR ii = 1 TO 12
2350    FOR j = 0 TO 4
2360        sliceout_tp (j)
2370        rotate slice ,'x', 3
2380        slicein_tp (j)
2390    END FOR j
2400    center_bounds
2410    zorder
2420    show_polyz
2430    FOR j = 0 TO 4
2440        sliceout_tp (j)
2450        rotate slice,'y',5
2460        slicein_tp (j)
2470    END FOR j
2480    center_bounds
2490    zorder
2500    show_polyz
2510 END FOR ii
2520 END DEFine turn_polyz
2530 :
2540 DEFine PROCedure poly_copy
2550 LOCal i,j,k
2560 REMark copy polygons from pa into array tp
2570 REMark make a working array and leave original pa as is ?
2580 REMark same elements as in pa?
2590 DIM tp(DIMN(pa),6,3)
2600 DIM tp_tagz%(DIMN(pa)-1)
2610 DIM tp_z(DIMN(pa)-1)
2620 FOR i = 0 TO DIMN(pa)
2630   REMark pick up tet edge and face # from pa
2640   tp(i,0,0) = pa(i,0,0)
2650   tp(i,1,0) = pa(i,1,0)
2660   tp(i,2,0) = pa(i,2,0)
2670   PRINT #0;"copying polygon # ";i;", edge ";tp(i,1,0);", face ";tp(i,2,0)
2680 REMark PAUSE
2690 REMark any uses for tp(i,[0,3 to 6],0)? direction cosines? etc.
2700   FOR j = 0 TO xyz
2710      tp(i,j+3,0) = fqa(tp(i,2,0),j)
2720   END FOR j
2730   s1 = p_to_s(i)
2740   s2 = n
2750   FOR j = 1 TO xyz
2760     tp(i,0,j)=pa(i,0,j)
2770     FOR k = 1 TO 4
2780        tp(i,k,j) = sva(sa(s1,s2,k),j)
2790     END FOR k
2800   END FOR j
2810 END FOR i
2820 END DEFine poly_copy
2830 :
2840 DEFine PROCedure center_bounds
2850 REMark put center z into tp_z and figure bounding box
2860 FOR i = 1 TO DIMN(tp)
2870    tp_z(i-1) = tp(i,0,3)
2880    DIM min_max(2,xyz)
2890    FOR j = 1 TO xyz
2900       min_max(1,j) = 1E616 : min_max(2,j) = -1E616
2910    END FOR j
2920    FOR j = 1 TO 4
2930       FOR k = 1 TO xyz
2940          IF tp(i,j,k) < min_max(1,k) : min_max(1,k) = tp(i,j,k)
2950          IF tp(i,j,k) > min_max(2,k) : min_max(2,k) = tp(i,j,k)
2960       END FOR k
2970    END FOR j
2980    FOR j = 1 TO xyz
2990       tp(i,5,j) = min_max(1,j)
3000       tp(i,6,j) = min_max(2,j)
3010    END FOR j
3020 REMark   PRINT #0;"Have centers and bounds for polygon ";i
3030 END FOR i
3040 END DEFine center_bounds
3050 :
3060 REMark that's the copy - now how about a turn about ?
3070 REMark in keeping with previous revolve PROC
3080 REMark and close with something from adjust ?
3090 :
3100 REMark first we sort on the z values
3110 REMark and then use show_polyz ( vs. the show_polys )
3120 REMark show_polyz will transit vertices with FILL 1
3130 REMark show_polys transited edges
3140 :
3150 DEFine PROCedure zorder
3160 I_FILL tp_tagz%,0,1
3170 SORT tp_z,1,tp_tagz%
3180 END DEFine zorder
3190 :
3200 DEFine PROCedure show_polyz
3210 LOCal i,j,p_n
3220 CLS
3230 FOR i = 0 TO DIMN(tp_z)
3240    p_n = 1 + tp_tagz%(i)
3250    edge_num = tp(p_n,1,0)
3260    face_num = tp(p_n,2,0)
3270    INK ink4(cyc (face_num, DIMN(ink4)))
3280    FILL 1
3290    POINT tp(p_n,4,1),tp(p_n,4,2)
3300    FOR j = 1 TO 4
3310      LINE TO tp(p_n,j,1),tp(p_n,j,2)
3320    END FOR j
3330    FILL 0
3340 END FOR i
3350 PAUSE 2
3360 END DEFine show_polyz
3370 :
3380 DEFine PROCedure sliceout_tp(index)
3390 LOCal i,j
3400 DIM slice(DIMN(tp),3)
3410 FOR i = 0 TO DIMN(tp)
3420    FOR j = 1 TO xyz
3430       slice(i,j) = tp(i,index,j)
3440    END FOR j
3450 END FOR i
3460 END DEFine sliceout_tp
3470 :
3480 DEFine PROCedure slicein_tp(index)
3490 LOCal i,j
3500 FOR i = 0 TO DIMN(tp)
3510    FOR j = 1 TO xyz
3520       tp(i,index,j) = slice(i,j)
3530    END FOR j
3540 END FOR i
3550 END DEFine slicein_tp
3560 :
3570 :
3580 DEFine PROCedure show_polys (za,pa,sa,sva,seva)
3590 LOCal i,j,k
3600 REMark gets tricky with pointers to pointers ?
3610 REMark CLS
3620 REMark CLS #0
3630 FOR i = 0 TO DIMN(za)
3640    poly_num = 1 + za(i)
3650    REMark PRINT #0;"polygon ";poly_num
3660    s1 = p_to_s (poly_num)
3670    s2 = n
3680    REMark  choose color by edge or by face ?
3690    edge_num = pa(poly_num,1,0)
3700    face_num = sa(s1,s2,0)
3710    REMark bounding values in pa(poly_num,[1=min,2=max],[xyz])
3720    REMark INK ink4(cyc(edge_num,DIMN(ink4)))
3730    INK ink4(cyc(face_num,DIMN(ink4)))
3740    FILL 1
3750 REMark equation of plane in fqa(face_num,[0 to 10] ?
3760    FOR j = 1 TO 4
3770       show_edge seva,sva,sa(s1,s2,j+4)
3780    END FOR j
3790    FILL 0
3800 END FOR i
3810 PAUSE 30
3820 END DEFine show_polys
3830 :
3840 REMark building 'sa' integer pointer to vertices
3850 REMark using edge to face link, vertex array, edge to vertex array
3860 REMark and making v_list and e_list for use in order_ve
3870 ::
3880 DEFine PROCedure make_polys(sa,efa,sva,seva,pa,pza)
3890 LOCal i,j,k
3900 CLS
3910 CLS#0
3920 PRINT #0;"getting polygons to struts for ";PS_name$(PS)
3930 REMark FOR i = 1 TO edges
3940 PRINT #0;"for 1 to ";DIMN(sa)
3950 FOR i = 1 TO DIMN(sa)
3960  FOR j = 1 TO 2
3970   REMark set polygon number
3980   poly_num = s_to_p(i,j)
3990 REMark what tet_num ?
4000 tet_num = (poly_num - 1) DIV (edges*2) + 1
4010 pa(poly_num,0,0) = tet_num
4020 REMark hold tet owner 
4030   REMark hold edge owner
4040   pa(poly_num,1,0) = i
4050   DIM v_list(4)
4060   DIM e_list(4)
4070   e_list(1) = i
4080   REMark the face in question
4090   face_num = efa(i,j)
4100   REMark hold face owner 
4110   pa(poly_num,2,0) = face_num
4120   sa(i,j,0) = face_num
4130   REMark vertices of the outside edge
4140   v_list(1) = seva(i,1) : v_list(2) = seva(i,2)
4150   FOR k = edges+1 TO DIMN(seva)
4160    IF seva(k,0)=face_num THEN
4170     REMark radial 1 and chord begin (1)
4180      IF v_list(1) = seva(k,1) THEN
4190       r1 = k : ch1 = seva(k,2)
4200       v_list(3) = seva(k,2)
4210       e_list(2) = r1
4220      END IF
4230      REMark radial 2 and chord end (2)
4240      IF v_list(2) = seva(k,1) THEN
4250       r2 = k : ch2 = seva(k,2)
4260       v_list(4) = seva(k,2)
4270       e_list(4) = r2
4280      END IF
4290     END IF
4300    END FOR k
4310    FOR k = edges+1 TO DIMN(seva)
4320     IF ((ch1 = seva(k,1)) AND (ch2 = seva(k,2))) : ch = k
4330     IF ((ch1 = seva(k,2)) AND (ch2 = seva(k,1))) : ch = k
4340    END FOR k
4350    e_list(3) = ch
4360    REMark go ahead and fill sa even though out of order
4370    FOR k = 1 TO 4
4380     sa(i,j,k) = v_list(k)
4390     sa(i,j,k+4)= e_list(k)
4400    END FOR k
4410    REMark now we have the 4 edges, but not in order
4420    REMark now we have the 4 vertices, but not in order
4430    INK ink4(face_num)
4440    FILL 1
4450    FOR k = 1 TO 4
4460      show_edge seva,sva,e_list(k)
4470     END FOR k
4480     FILL 0
4490 PRINT#0; "edge ";i;" face ";face_num,i,r1,ch,r2,
4500 IF PS = 6 : PRINT #0;"tet# ";tet_num
4510 IF PS < 6 : PRINT #0
4520 REMark PAUSE
4530    REMark find center of polygon and put edges and vertices in order
4540    order_ve 4,v_list,e_list
4550    FOR k = 1 TO 4
4560     sa(i,j,k)   = v_list(k)
4570     sa(i,j,k+4) = e_list(k)
4580    END FOR k
4590   END FOR j
4600  END FOR i
4610  CLS
4620  REMark CLS #0
4630  FOR f = 1 TO faces
4640 REMark  PRINT #0,"face ";f,
4650   INK ink4(f)
4660   FOR i = 1 TO DIMN(sa)
4670    FOR j = 1 TO 2
4680     IF sa(i,j,0) = f THEN
4690      FILL 1
4700      FOR k = 5 TO 8
4710       show_edge seva, sva, sa(i,j,k)
4720      END FOR k
4730      FILL 0
4740     END IF
4750    END FOR j
4760   END FOR i
4770  END FOR f
4780  PAUSE 10
4790  CLS
4800  REMark CLS #0
4810  REMark color by edge
4820  FOR i = 1 TO DIMN(sa)
4830   INK  ink4(cyc (i,21))
4840 REMark  PRINT #0;"edge ";i,
4850   FOR j = 1 TO 2
4860    FILL 1
4870    FOR k = 5 TO 8
4880      show_edge seva, sva, sa(i,j,k)
4890    END FOR k
4900    FILL 0
4910   END FOR j
4920  END FOR i
4930 END DEFine make_polys
4940 :
4950 REMark a lot of this is taken from the get_faces PROC
4960 REMark a general procedure to arrange vertices and edges in order
4970 REMark for any polygon ?
4980 REMark parameters are : number of vertices(edges)
4990 REMark vertex list, edge list (usually as pointers to ->
5000 REMark vertex array of xyz values, and edge to vertex link
5010 REMark polygon array an intrusion ?
5020 REMark center and bounds universal?
5030 :
5040 DEFine PROCedure order_ve (nv,vl,el)
5050 LOCal i,j,k
5060 REMark PRINT #0 ;"Ordering vertices and edges for polygon"
5070 REMark make a working array for each polygon
5080 REMark find bounding box for polygon
5090 DIM min_max(2,xyz)
5100 FOR i = 1 TO xyz
5110    min_max(1,i)=  1E616
5120    min_max(2,i)= -1E616
5130 END FOR i
5140 DIM worka(nv,xyz)
5150 FOR j = 1 TO nv
5160    REMark PRINT #0;j!vl(j)!!
5170    FOR k = 1 TO xyz
5180       worka(j,k) = sva(vl(j),k)
5190       IF min_max(1,k) > worka(j,k) : min_max(1,k) = worka(j,k)
5200       IF min_max(2,k) < worka(j,k) : min_max(2,k) = worka(j,k)
5210       REMark summing the values in 0th element
5220       worka(0,k) = worka(0,k) + worka(j,k)
5230    END FOR k
5240 END FOR j
5250 CLS
5260 REMark INK ink4(4)
5270 REMark show_face worka
5280 REMark now find the center of the polygon
5290 REMark and put it in poly_array pa(poly_num)
5300 REMark INK ink4(6)
5310 REMark LINE 0,-10 TO 0,10
5320 REMark LINE -10,0 TO 10,0
5330 REMark also put bounding values in pa(poly_num)
5340 FOR j = 1 TO 3
5350    worka(0,j) = worka(0,j)/nv
5360    pa(poly_num,0,j) = worka(0,j)
5370    REMark p,1,xyz minimum values
5380    pa(poly_num,1,j) = min_max(1,j)
5390    REMark p,2,xyz maximum values
5400    pa(poly_num,2,j) = min_max(2,j)
5410 END FOR j
5420 REMark attempt to pick up center z value ?
5430 pza(poly_num-1)= worka(0,3)
5440 REMark INK ink4(2)
5450 REMark CIRCLE 0,0,2E-2
5460 REMark LINE 0,0 TO worka(0,1),worka(0,2)
5470 REMark show_face worka
5480 :
5490 REMark now rotate about x axis by some amount of y
5500 REMark so as to center face at y = 0
5510 REMark look at it on yz plane
5520 rot_x = -angl_frm (0,0,worka(0,3),worka(0,2))
5530 rotate worka, 'x', rot_x
5540 REMark INK ink4(4)
5550 REMark show_face worka
5560 REMark LINE 0,0 TO worka(0,1),worka(0,2)
5570 REMark INK ink4(6)
5580 REMark CIRCLE worka(0,1),worka(0,2),4E-2
5590 :
5600 REMark now rotate about y axis by some amount of x
5610 REMark so as to center at x = 0
5620 REMark look at it on xz plane
5630 rot_y = angl_frm(0,0,worka(0,3),worka(0,1))
5640 rotate worka, 'y', rot_y
5650 :
5660 REMark CLS
5670 REMark INK ink4(4)
5680 REMark show_face worka
5690 REMark INK ink4(2)
5700 REMark LINE 0,0 TO worka(0,1),worka(0,2)
5710 REMark CIRCLE 0,0,2E-2
5720 REMark INK ink4(6)
5730 REMark CIRCLE worka(0,1),worka(0,2),4E-2
5740 :
5750 REMark then can check bearings and sort out vertices & linking edges
5760 DIM bear_list(nv)
5770 FOR j = 1 TO nv
5780    bear_list(j)= angl_frm(0,0,worka(j,1),worka(j,2))
5790    REMark LINE 0,0 TO worka(j,1),worka(j,2)
5800    REMark PRINT bear_list(j)
5810 END FOR j
5820 REMark now sort them out by size
5830 REPeat dumbsort
5840 swaps = 0
5850 FOR j = 2 TO nv
5860    IF bear_list(j-1)>bear_list(j) THEN
5870       swaps = swaps + 1
5880       swap bear_list(j-1),bear_list(j)
5890       swap vl(j-1),vl(j)
5900       FOR k = 1 TO 3
5910          swap worka(j-1,k),worka(j,k)
5920       END FOR k
5930    END IF
5940 END FOR j
5950 IF swaps = 0 : EXIT dumbsort
5960 END REPeat dumbsort
5970 CLS
5980 REMark show_face worka
5990 REMark put the face back where it was
6000 rotate worka, 'y', -rot_y
6010 rotate worka, 'x', -rot_x
6020 REMark show where it came from
6030  INK ink4(2)
6040  show_face worka
6050  INK ink4(4)
6060 :
6070 REMark now to put edges in order
6080 FOR j = 1 TO nv
6090    REMark PRINT #0;j;" to ";
6100    REMark vl(j) is beginning vertex
6110    jj = cyc ((j + 1),nv)
6120    REMark PRINT #0;jj, vl(j),vl(jj)
6130    REMark jj points to the next vertex vl(jj)
6140    REMark now what edge matches this ?
6150    FOR k = 1 TO nv
6160       REMark PRINT #0;k,
6170       REMark the matching edge will be k
6180       REMark PRINT #0;seva(el(k),1),seva(el(k),2)
6190       IF (((seva(el(k),1)= vl(j) AND seva(el(k),2)= vl(jj)) OR                     (seva(el(k),2)= vl(j) AND seva(el(k),1)= vl(jj)))) THEN
6200         IF k <> j  THEN
6210            swap el(k),el(j)
6220         END IF
6230 REMark        POINT  sva(seva(el(k),1),1),sva(seva(el(k),1),2)
6240 REMark        LINE TO  sva(seva(el(k),2),1),sva(seva(el(k),2),2)
6250       END IF
6260    END FOR k
6270 END FOR j
6280 INK 2
6290 END DEFine order_ve
6300 :
6310 DEFine FuNction s_to_p (e,f)
6320 REMark convert strut (edge, face) to poly (p_num)
6330 RETurn (e-1)*2 + f
6340 END DEFine s_to_p
6350 :
6360 DEFine FuNction p_to_s(p)
6370 REMark convert Poly (p) to strut (edge,face)
6380 e = (p+1) DIV 2
6390 n = cyc (p,2)
6400 RETurn e
6410 RETurn n
6420 END DEFine p_to_s
6430 :
6440 REMark for sorting Z-values {= t_p(#,0,3)}
6450 REMark as an integer pointer for the SORT call.
6460 :
6470 REMark cube
6480 DEFine PROCedure build_cube
6490 PS = 2
6500 get_PS_nums(PS)
6510 DIM c_v(vertices,xyz)
6520 DIM c_ve%(vertices,q)
6530 DIM c_vf%(vertices,q)
6540 DIM c_ev%(edges,2)
6550 DIM c_ef%(edges,2)
6560 DIM c_fv%(faces,p)
6570 DIM c_fe%(faces,p)
6580 DIM c_fq(faces,10)
6590 DIM c_sv(vertices+faces*p,xyz)
6600 DIM c_sev%(edges+faces*2*p,2)
6610 DIM c_tagz%(edges*2 - 1)
6620 DIM c_s%(edges,2,8) : REMark links to c_sev%
6630 DIM c_p(edges*2,2,3) : REMark links to c_sv
6640 DIM c_z(edges*2 - 1)
6650 cl = 2
6660 REMark cl is length of edge of cube
6670 RESTORE 23100
6680 get_vertices c_v
6690 INK ink4(PS) :  CLS : CLS #0
6700 show_vertices c_v
6710 PRINT#0; "have vertices for ";PS_name$(PS)
6720 get_edges c_ev%,c_v,cl
6730 show_edges c_ev%,c_v
6740 PRINT#0; " have edges for ";PS_name$(PS)
6750 get_vertex_to_edges c_ve%,c_v,c_ev%
6760 PRINT#0; "have Vertex to edges for ";PS_name$(PS)
6770 get_faces c_fv%,c_fe%, c_ef%, c_vf%, c_v, c_ev%, c_ve%, c_fq
6780 PRINT #0 ;"have faces for ";PS_name$(PS)
6790 PAUSE 30
6800 REMark review_links PS,c_v,c_ve%,c_vf%,c_ev%,c_ef%,c_fv%,c_fe%,c_fq
6810 REMark PAUSE
6820 CLS#0
6830 PRINT #0;"revolving wire-frame for ";PS_name$(PS)
6840 revolve c_ev% , c_v
6850 REMark adjust c_ev% , c_v
6860 :
6870 CLS  : CLS  #0
6880 show_faces c_fv%, c_v, c_fq
6890 turn_faces PS, c_fv%, c_v, c_fq
6900 make_struts c_v,c_fq,c_ev%,c_fv%,c_sv,c_sev%
6910 CLS#0
6920 PRINT #0;"revolving wire-frame ";PS_name$(PS);" with struts"
6930 revolve c_sev% ,c_sv
6940 REMark adjust c_sev% , c_sv
6950 make_polys c_s%,c_ef%,c_sv,c_sev%,c_p,c_z
6960 :
6970 I_FILL c_tagz%,0,1
6980 SORT c_z,1,c_tagz%
6990 show_polys c_tagz%,c_p,c_s%,c_sv,c_sev%
7000 :
7010 turn_polyz c_p,c_fq,c_s%,c_sv
7020 END DEFine build_cube
7030 :
7040 REMark octahedron
7050 DEFine PROCedure build_octahedron
7060 PS = 3
7070 get_PS_nums(PS)
7080 DIM o_v(vertices,3) : DIM o_ve%(vertices,q) : DIM o_vf%(vertices,q)
7090 DIM o_ev% (edges,2) : DIM o_ef%(edges,2)
7100 DIM o_fv%(faces,p) : DIM o_fe%(faces,p) :DIM o_fq(faces,10)
7110 DIM o_sv(vertices+faces*p,xyz)
7120 DIM o_sev%(edges+faces*2*p,2)
7130 DIM o_tagz%(edges*2 - 1)
7140 ol = SQRT(2)
7150 DIM o_s%(edges,2,8) : REMark links to o_sev%
7160 DIM o_p(edges*2,2,3) : REMark links to o_sv
7170 DIM o_z(edges*2 - 1)
7180 REMark ol is length of edge of octahedron
7190 RESTORE 23210
7200 get_vertices o_v
7210 REMark they seem small so lets expand by sqrt(2) = ol
7220 FOR i = 1 TO vertices
7230 FOR j = 1 TO xyz
7240 o_v(i,j) = o_v(i,j)* ol
7250 END FOR j
7260 END FOR i
7270 ol = ol * ol
7280 INK ink4(PS) :  CLS  : CLS #0
7290 show_vertices o_v
7300 PRINT#0; "have vertices for octahedron"
7310 get_edges o_ev% ,o_v,ol
7320 show_edges o_ev% ,o_v
7330 PRINT#0; " have edges for octahedron"
7340 get_vertex_to_edges o_ve%,o_v,o_ev%
7350 PRINT#0; "have Vertex to edges for octahedron"
7360 get_faces o_fv%,o_fe%, o_ef%, o_vf%, o_v, o_ev% , o_ve%, o_fq
7370 PRINT #0 ;"have faces for octahedron"
7380 PAUSE  30
7390 REMark review_links PS,o_v,o_ve%,o_vf%,o_ev%,o_ef%,o_fv%,o_fe%,o_fq
7400 REMark PAUSE
7410 CLS#0
7420 PRINT #0;"revolving wire-frame for ";PS_name$(PS)
7430 revolve o_ev% , o_v
7440 REMark adjust o_ev% , o_v
7450 make_struts o_v,o_fq,o_ev%,o_fv%,o_sv,o_sev%
7460 CLS#0
7470 PRINT #0;"revolving wire-frame ";PS_name$(PS);" with struts"
7480 revolve o_sev% ,o_sv
7490 REMark adjust o_sev% , o_sv
7500 CLS  :  CLS #0
7510 show_faces o_fv%, o_v, o_fq
7520 turn_faces PS, o_fv%, o_v, o_fq
7530 make_polys o_s%,o_ef%,o_sv,o_sev%,o_p,o_z
7540 :
7550 I_FILL o_tagz%,0,1
7560 SORT o_z,1,o_tagz%
7570 show_polys o_tagz%,o_p,o_s%,o_sv,o_sev%
7580 :
7590 turn_polyz o_p,o_fq,o_s%,o_sv
7600 END DEFine build_octahedron
7610 :
7620 REMark dodecahedron
7630 DEFine PROCedure build_dodecahedron
7640 PS = 4
7650 get_PS_nums(PS)
7660 REMark use 0 for distance from 0,0,0 [ = sqrt(3)]
7670 DIM d_v(vertices,xyz) : DIM d_ve%(vertices,q) : DIM d_vf%(vertices,q)
7680 DIM d_ev%(edges,2) : DIM d_ef%(edges,2)
7690 DIM d_fv%(faces,p) : DIM d_fe%(faces,p) :DIM d_fq(faces,10)
7700 DIM d_sv(vertices+faces*p,xyz)
7710 DIM d_sev%(edges+faces*2*p,2)
7720 DIM d_tagz%(edges*2 - 1)
7730 DIM d_z(edges*2 - 1)
7740 dl = 2*itau
7750 DIM d_s%(edges,2,8) : REMark links to d_sev%
7760 DIM d_p(edges*2,2,3) : REMark links to d_sv
7770 REMark dl is length of edge of dodecahedron
7780 dcr = SQRT(3)
7790 REMark circumscribing radius of dodecahedron
7800 RESTORE 22590
7810 get_vertices d_v
7820 INK ink4(PS) :  CLS : CLS #0
7830 show_vertices d_v
7840 PRINT#0; "have vertices for ";PS_name$(PS)
7850 get_edges d_ev%, d_v, dl
7860 show_edges d_ev% ,d_v
7870 PRINT#0; " have edges for ";PS_name$(PS)
7880 get_vertex_to_edges d_ve%,d_v,d_ev%
7890 PRINT#0; "have Vertex to edges for ";PS_name$(PS)
7900 get_faces d_fv%,d_fe%, d_ef%, d_vf%, d_v, d_ev% , d_ve%, d_fq
7910 PRINT #0 ;"have faces for ";PS_name$(PS)
7920 PAUSE  30
7930 REMark review_links PS,d_v,d_ve%,d_vf%,d_ev%,d_ef%,d_fv%,d_fe%,d_fq
7940 REMark PAUSE
7950 CLS#0
7960 PRINT #0;"revolving wire-frame for ";PS_name$(PS)
7970 revolve d_ev%,d_v
7980 REMark adjust d_ev% , d_v
7990 CLS  :  CLS#0
8000 show_faces d_fv%, d_v, d_fq
8010 turn_faces PS, d_fv%, d_v, d_fq
8020 make_struts d_v,d_fq,d_ev%,d_fv%,d_sv,d_sev%
8030 CLS#0
8040 PRINT #0;"revolving wire-frame ";PS_name$(PS);" with struts"
8050 revolve d_sev% ,d_sv
8060 REMark adjust d_sev% , d_sv
8070 make_polys d_s%, d_ef%, d_sv, d_sev%, d_p, d_z
8080 :
8090 I_FILL d_tagz%,0,1
8100 SORT d_z,1,d_tagz%
8110 show_polys d_tagz%,d_p,d_s%,d_sv,d_sev%
8120 :
8130 turn_polyz d_p,d_fq,d_s%,d_sv
8140 END DEFine build_dodecahedron
8150 :
8160 REMark icosahedron
8170 DEFine PROCedure build_icosahedron
8180 PS = 5
8190 get_PS_nums(PS)
8200 REMark the icosahedron being the 'dual' of the dodecahedron
8210 DIM i_v(vertices,xyz) : DIM i_ve%(vertices,q) : DIM i_vf%(vertices,q)
8220 DIM i_ev%(edges,2) : DIM i_ef%(edges,2)
8230 DIM i_fv%(faces,p) : DIM i_fe%(faces,p) : DIM i_fq(faces,10)
8240 DIM i_sv(vertices+faces*p,xyz)
8250 DIM i_sev%(edges+faces*2*p,2)
8260 DIM i_tagz%(edges*2 - 1)
8270 il = 2
8280 DIM i_s%(edges,2,8) : REMark links to i_sev%
8290 DIM i_p(edges*2,2,3) : REMark links to i_sv
8300 DIM i_z(edges*2 - 1)
8310 REMark il is length of edge of icosahedron
8320 RESTORE 22820
8330 get_vertices i_v
8340 INK ink4(PS) :  CLS : CLS #0
8350 show_vertices i_v
8360 PRINT#0; "have vertices for ";PS_name$(PS)
8370 get_edges i_ev%,i_v,il
8380 show_edges i_ev%,i_v
8390 PRINT#0; " have edges for ";PS_name$(PS)
8400 get_vertex_to_edges i_ve%,i_v,i_ev%
8410 PRINT#0; "have Vertex to edges for ";PS_name$(PS)
8420 get_faces i_fv%,i_fe%, i_ef%, i_vf%, i_v, i_ev%, i_ve%, i_fq
8430 PRINT #0 ;"have faces for ";PS_name$(PS)
8440 PAUSE 30
8450 REMark review_links PS,i_v,i_ve%,i_vf%,i_ev%,i_ef%,i_fv%,i_fe%,i_fq
8460 REMark PAUSE
8470 CLS#0
8480 PRINT #0;"revolving wire-frame ";PS_name$(PS)
8490 revolve i_ev%, i_v
8500 CLS  : CLS  #0
8510 show_faces i_fv%, i_v, i_fq
8520 turn_faces PS, i_fv%, i_v, i_fq
8530 REMark adjust i_ev% , i_v
8540 make_struts i_v,i_fq,i_ev%,i_fv%,i_sv,i_sev%
8550 CLS#0
8560 PRINT #0;"revolving wire-frame ";PS_name$(PS);" with struts"
8570 revolve i_sev% , i_sv
8580 REMark adjust i_sev% , i_sv
8590 make_polys i_s%,i_ef%,i_sv,i_sev%, i_p, i_z
8600 :
8610 I_FILL i_tagz%,0,1
8620 SORT i_z,1,i_tagz%
8630 show_polys i_tagz%,i_p, i_s%,i_sv,i_sev%
8640 :
8650 turn_polyz i_p,i_fq,i_s%,i_sv
8660 END DEFine build_icosahedron
8670 :
8680 REMark /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
8690 REMark Two Sets of Five Intersecting Tetrahedra
8700 DEFine PROCedure build_FIT
8710 INK 4 : CLS
8720 CLS #0
8730 PS = 6
8740 get_PS_nums (PS)
8750 REMark allow for the two sets of 5 intersecting tetrahedra
8760 REMark as in the modular origami
8770 REMark with struts of variable width s_w
8780 REMark 3 trapezoidal polygons per face
8790 REMark 2 sets, 5 tetrahedra, 4 faces, 3 trapezoids
8800 REMark each trapezoid has 4 lines, each line has 2 ends
8810 REMark 2 * 5 * 4 * 3 trapezoids a total of 120 trapezoids !
8820 REMark 2 new points for each trapezoid with xyz values
8830 REMark to be combined with existing vertices, edges etc.
8840 :
8850 REMark Begin with the outer vertex, edge, face arrays
8860 DIM fit_v(2,5,vertices,xyz) : DIM fit_vf%(2,5,vertices,q) : DIM fit_ve%(2,5,vertices,q)
8870 DIM fit_ev%(2,5,edges,2) : DIM fit_ef%(2,5,edges,2)
8880 DIM fit_fv%(2,5,faces,p): DIM fit_fe%(2,5,faces,p) : DIM fit_fq(2,5,faces,10)
8890 :
8900 REMark now add the strut vertex, edge, tagz, polygon arrays
8910 :
8920 DIM fit_sv(2,5,vertices+faces*p,xyz)
8930 DIM fit_sev%(2,5,edges+faces*2*p,2)
8940 DIM fit_s%(2,5,edges,2,8) : REMark links to fit_sev%
8950 DIM fit_p(2,5,edges*2,2,3) : REMark links to fit_sv
8960 DIM fit_tagz%(2,5,edges*2 -1) :REMark for SORT of z array
8970 DIM fit_z(2,5,edges*2 - 1) : REMark Z-buffer, etc.
8980 fitl = 2*SQRT(2)
8990 RESTORE 23470
9000 REMark the vertices x,y,z which are in DATA Statements
9010 FOR set = 1 TO 2
9020  FOR tet = 1 TO 5
9030 INK FIT_color(tet,set)
9040    get_vertices fit_v(set,tet)
9050 REMark PRINT "Got vertices" : PAUSE
9060    show_vertices fit_v(set,tet)
9070    get_edges fit_ev%(set,tet),fit_v(set,tet),fitl
9080 REMark PRINT "Got edges" : PAUSE
9090    show_edges fit_ev%(set,tet), fit_v(set,tet)
9100    get_vertex_to_edges fit_ve%(set,tet),fit_v(set,tet),fit_ev%(set,tet)
9110 REMark PRINT "Got vertex to edge links" : PAUSE
9120  END FOR tet
9130 END FOR set
9140 :
9150 REMark  that gets the outer vertices and edges
9160 :
9170 REMark now go for the face links 
9180 :
9190 FOR set = 1 TO 2
9200  FOR tet = 1 TO 5
9210   get_faces fit_fv%(set,tet), fit_fe%(set,tet), fit_ef%(set,tet), fit_vf%(set,tet), fit_v(set,tet), fit_ev%(set,tet), fit_ve%(set,tet), fit_fq(set,tet)
9220 REMark PRINT "Got faces" : PAUSE
9230 REMark review_links PS,fit_v(set,tet),fit_ve%(set,tet),fit_vf%(set,tet),fit_ev%(set,tet),fit_ef%(set,tet),fit_fv%(set,tet),fit_fe%(set,tet),fit_fq(set,tet)
9240 REMark PRINT "Reviewed Links Set ";set;" Tetrahedra ";tet:PAUSE
9250 :
9260 REMark now the strut vertices and edges 
9270 :
9280 make_struts fit_v(set,tet),fit_fq(set,tet),fit_ev%(set,tet),fit_fv%(set,tet),fit_sv(set,tet),fit_sev%(set,tet)
9290 CLS#0
9300 PRINT #0;"revolving wire-frame ";PS_name$(PS);" set ";set;", tet ";tet
9310 revolve fit_sev%(set,tet) ,fit_sv(set,tet)
9320 make_polys fit_s%(set,tet),fit_ef%(set,tet),fit_sv(set,tet),fit_sev%(set,tet), fit_p(set,tet),fit_z(set,tet)
9330 I_FILL fit_tagz%(set,tet),0,1
9340 SORT fit_z(set,tet),1,fit_tagz%(set,tet)
9350 show_polys fit_tagz%(set,tet),fit_p(set,tet),fit_s%(set,tet),fit_sv(set,tet),fit_sev%(set,tet)
9360 turn_polyz fit_p(set,tet),fit_fq(set,tet),fit_s%(set,tet),fit_sv(set,tet)
9370 :
9380  END FOR tet
9390 CLS #0
9400 REMark PRINT #0;"revolving wire-frame ";PS_name$(PS);" set ";set;", tet ";tet;" with struts"
9410 END FOR set
9420 :
9430 REMark OK so far ! Dec 6th
9440 REMark =.=.=.=.=.=..=.=.=.=.=.=.=.=.=.=.=
9450 :
9460 REMark PAUSE
9470 REMark now to make the super set of five
9480 REMark also/ or FitsL and FitsR for 2 versions ?
9490 :
9500 REMark a set of Functions to convert v, e, f, etc.        ???
9510 REMark to and from the fit_(2,5,...) to the fits_(5*?,...) ???
9520 :
9530 :
9540 FOR set = 1 TO 2
9550  REMark create  super sets of five ?
9560  DIM fits_s%(5*edges,2,8)
9570  DIM FitsL_s%(5*edges,2,8)
9580  DIM FitsR_s%(5*edges,2,8)
9590  REMark 30 struts, 2 polys each
9600  e_f2p = edges + (faces * 2 * p)
9610  DIM fits_ef%(5*e_f2p,2)
9620  DIM FitsL_ef%(5*e_f2p,2)
9630  DIM FitsR_ef%(5*e_f2p,2)
9640  REMark 30 original edges with 2 faces + 120 edges with 1 face = 150
9650  v_fp = vertices+faces*p
9660  DIM fits_sv(5*(v_fp),xyz)
9670  DIM FitsL_sv(5*(v_fp),xyz)
9680  DIM FitsR_sv(5*(v_fp),xyz)
9690  REMark 80 sv
9700  DIM fits_sev%(5*(e_f2p),2)
9710  DIM FitsL_sev%(5*(e_f2p),2)
9720  DIM FitsR_sev%(5*(e_f2p),2)
9730  DIM fits_fq(5*faces,10)
9740  DIM FitsL_fq(5*faces,10)
9750  DIM FitsR_fq(5*faces,10)
9760  REMark 20 faces
9770  DIM fits_p(5*edges*2,2,3)
9780  DIM FitsL_p(5*edges*2,2,3)
9790  DIM FitsR_p(5*edges*2,2,3)
9800  REMark 60 polygons (based on the original outside edges)
9810  FOR tet = 1 TO 5
9820   :
9830   REMark   _sv 5*(v_fp),xyz
9840   FOR j = 1 TO v_fp
9850    FOR k = 1 TO xyz
9860     fits_sv(j+(tet-1)*v_fp,k) = fit_sv(set,tet,j,k)
9870     IF set = 1: FitsL_sv(j+(tet-1)*v_fp,k) =  fits_sv(j+(tet-1)*v_fp,k)
9880     IF set = 2: FitsR_sv(j+(tet-1)*v_fp,k) =  fits_sv(j+(tet-1)*v_fp,k)
9890    END FOR k
9900   END FOR j
9910   :
9920   REMark _sev%  5*(e_f2p), 2
9930   FOR j = 1 TO e_f2p
9940    j_k = j+(tet-1)*e_f2p
9950    fits_sev%(j_k,0)=tet
9960    FOR k = 1 TO 2
9970     fits_sev%(j+(tet-1)*e_f2p,k) = fit_sev%(set,tet,j,k)+(tet-1)*v_fp
9980     IF set = 1 : FitsL_sev%(j+(tet-1)*e_f2p,k) = fits_sev%(j+(tet-1)*e_f2p,k)
9990     IF set = 2 : FitsR_sev%(j+(tet-1)*e_f2p,k) = fits_sev%(j+(tet-1)*e_f2p,k)
10000   END FOR k
10010 END FOR j
10020 :
10030 CLS#0
10040 PRINT #0;"revolving wire-frames ";PS_name$(PS);" set ";set;" with struts in tet(s) ";
10050 :
10060 CLS
10070 show_edges fit_sev%(set,tet), fit_sv(set,tet)
10080 FOR j = 1 TO tet
10090  PRINT #0;j!!
10100 END FOR j
10110 END FOR tet
10120 END FOR set
10130 :
10140 REMark the wire grid struts
10150 FOR set = 1 TO 2
10160 FOR tet = 1 TO 5
10170 show_edges fit_sev%(set,tet), fit_sv(set,tet)
10180 END FOR tet
10190 REMark END FOR set
10200 :
10210 revolve fits_sev%, fits_sv
10220 REMark seems OK to here  Dec 6th
10230 END FOR set
10240 :
10250 FOR set = 1 TO 2
10260 FOR tet = 1 TO 5
10270 show_polys fit_tagz%(set,tet),fit_p(set,tet),fit_s%(set,tet),fit_sv(set,tet),fit_sev%(set,tet)
10280 END FOR tet
10290 END FOR set
10300 REMark OK to here  Dec 6th
10310 :
10320 FOR set =  1  TO 2
10330 FOR tet = 1 TO 5
10340  turn_polyz fit_p(set,tet),fit_fq(set,tet),fit_s%(set,tet),fit_sv(set,tet)
10350 END FOR tet
10360 END FOR set
10370 :
10380 REMark OK to here  Dec. 7th
10390 :
10400 REMark Begin FITS_S... arrays
10410 REMark here's where it needs work!
10420 REMark Perhaps a FitsL and FitsR for set 1 and set 2 ?
10430 FOR set = 1 TO 2
10440 FOR tet = 1 TO 5
10450  REMark an array that holds vertex to edges links ?
10460  REMark now each sv can link with 3 (inner) or 6 (outer) se
10470  DIM fits_sve%(5*v_fp,6)
10480  get_vertex_to_edges fits_sve%, fits_sv, fits_sev%
10490  REMark that  seems OK Dec 8th
10500  REMark need fv% , fe%, vf%, ve%
10510  REMark try get face links
10520  REMark f to sv links 6 sv per face or 2*p
10530  DIM fits_sfv%(5*faces,2*p)
10540  REMark f to se links 9 se per face or 3*p
10550  DIM fits_sfe%(5*faces,3*p)
10560  REMark sv to f links  can be 1 (inner) or 3 (outer)
10570  DIM fits_svf%(5*v_fp,q)
10580  :
10590 REMark   get_faces fits_sfv%, fits_sfe%, fits_sef%, fits_svf%, fits_sv, fits_sev%, fits_sve%, fits_sfq
10600  REMark     _s%   5*edges , 2, 8
10610   PRINT "OK at 10610 ?": PAUSE 20
10620  RESTORE 10610
10630  REMark    -ef%  5*edges, faces
10640  FOR j = 1 TO edges
10650   FOR k = 1 TO 2
10660    fits_ef%(j+(tet-1)*e_v2p,k) = fit_ef%(set,tet,j,k) +(tet-1)*faces
10670    fits_s%(j+(tet-1)*edges,k,0) = tet
10680    REMark fits_s%(j+(tet-1)*edges,k,0) = fits_ef%(j+(tet-1)*e_f2p)
10690      FOR kk = 1 TO 4
10700 fits_s%(j+(tet-1)*edges,k,kk) = fit_s%(set,tet,j,k,kk)+(tet-1)*v_fp
10710      END FOR kk
10720          FOR kk = 5 TO 8
10730 fits_s%(j+(tet-1)*edges,k,kk) = fit_s%(set,tet,j,k,kk)+(tet-1)*e_f2p
10740          END FOR kk
10750      END FOR k
10760  END FOR j
10770 :
10780 REMark    _fq  5*faces,10
10790   FOR j = 1 TO faces
10800      FOR k = 0 TO 10
10810        fits_fq(j+(tet-1)*faces,k) = fit_fq(set,tet,j,k)
10820      END FOR k
10830   END FOR j
10840 END FOR tet
10850 END FOR set
10860 :
10870 REMark Maybe OK to here ? Dec 4 am ?
10880 :
10890 DIM fits_p(5*edges*2,2,xyz) : REMark see note below
10900 DIM FitsL_p(5*edges*2,2,xyz) : REMark see note below
10910 DIM FitsR_p(5*edges*2,2,xyz) : REMark see note below
10920 DIM fits_tagz%(5*edges*2 -1)
10930 DIM FitsL_tagz%(5*edges*2 -1)
10940 DIM FitsR_tagz%(5*edges*2 -1)
10950 DIM fits_z(5*edges*2 -1)
10960 DIM FitsL_z(5*edges*2 -1)
10970 DIM FitsR_z(5*edges*2 -1)
10980 :
10990 REMark   _p  5*edges*2,  2, xyz
11000 FOR tet = 1 TO 5
11010  FOR i = 1 TO edges * 2
11020      FOR j = 0 TO 2
11030          FOR k = 1 TO xyz
11040            fits_p((i+(tet-1)*2*edges),j,k) = fit_p(set,tet,i,j,k)
11050          END FOR k
11060      END FOR j
11070  END FOR i
11080 :
11090 REMark   _z  (edges*2)-1
11100 REMark NO need to collect the z values from the fit_z to the fits_z ?
11110 REMark this is done in make_polys
11120  FOR i = 0 TO ((edges*2)-1)
11130 REMark PRINT set,tet,i,,i+(tet-1)*((edges*2)-1) : PAUSE
11140      fits_z(i+(tet-1)*((edges*2))) = fit_z(set,tet,i)
11150  END FOR i
11160 END FOR tet
11170 END FOR set
11180 REMark this looks strange
11190  make_polys fits_s%,fits_ef%,fits_sv,fits_sev%,fits_p,fits_z
11200 :
11210 PAUSE 30
11220 :
11230 I_FILL fits_tagz%,0,1
11240 SORT fits_z,1,fits_tagz%
11250 :
11260 REMark These don't look right
11270  show_polys fits_tagz%,fits_p,fits_s%,fits_sv,fits_sev%
11280 PAUSE 30
11290  turn_polyz fits_p,fits_fq,fits_s%,fits_sv
11300 :
11310 END FOR set
11320 :
11330 INK #0 ,2
11340 :
11350 PRINT #0; FREE_MEM;" bytes of memory available  Touch any key"
11360 PAUSE
11370 CLS#0
11380 adjust fits_sev%, fits_sv
11390 CLS#0
11400 END DEFine build_FIT
11410 :
11420 :
11430 :
11440 :
11450 REMark .......................................................
11460 REMark beginning of Procedures and Functions
11470 REMark .......................................................
11480 REMark turn_polyz t_tagz%,t_p,t_fq,t_s%,t_sv,t_sev%
11490 :
11500 REMark '''''''''''''''''''''''
11510 DEFine PROCedure show_angles
11520 LOCal i , j
11530 CLS
11540 PRINT "Angular measures"
11550 PRINT "Platonic Solid  Dihedral Angle    Phi           Chi            Psi "
11560 FOR i = 1 TO 5
11570   PRINT\ PS_name$(i);
11580   FOR j = 0 TO 3
11590      PRINT TO 16+j*15;DMS(PS_angles(i,j));"";Mn;"'";INT(10*Sc)/10;'"';
11600   END FOR j
11610 END FOR i
11620 END DEFine show_angles
11630 REMark ,,,,,,,,,,,,,,,,,,,
11640 :
11650 REMark ''''''''''''''''''
11660 DEFine PROCedure show_vertices(vertex_array)
11670 REMark only in x,y plane
11680 LOCal i
11690 FOR i = 1 TO DIMN(vertex_array)
11700 REMark PRINT #0;"vertex ";i
11710  POINT vertex_array(i,1),vertex_array(i,2)
11720 REMark PAUSE
11730 END FOR i
11740 END DEFine show_vertices
11750 REMark ,,,,,,,,,,,,,,,,,,,
11760 :
11770 DEFine PROCedure show_edge (e_a, v_a, e_n)
11780 LINE v_a(e_a(e_n,1),1),v_a(e_a(e_n,1),2) TO v_a(e_a(e_n,2),1),v_a(e_a(e_n,2),2)
11790 END DEFine show_edge
11800 :
11810 REMark ''''''''''''''''''''
11820 DEFine PROCedure show_edges(edge_array,vertex_array)
11830 REMark only in x,y plane
11840 LOCal i,j
11850 FOR i = 1 TO DIMN(edge_array)
11860  INK  ink4(1+edge_array(i,0))
11870  REMark PRINT #0, "edge ";i
11880 show_edge edge_array,vertex_array,i
11890  REMark LINE vertex_array(edge_array(i,1),1),vertex_array(edge_array(i,1),2) TO vertex_array(edge_array(i,2),1),vertex_array(edge_array(i,2),2)
11900  REMark PAUSE
11910 END FOR i
11920 END DEFine show_edges
11930 REMark ,,,,,,,,,,,,,,,,,,
11940 :
11950 REMark ''''''''''''''''''
11960 DEFine PROCedure show_faces(fv_array,v_array,fq_array)
11970 REMark only in x,y plane
11980 LOCal i, ii, j, last_f, last_v, f_zs
11990 REMark z value for center of face is fq_array(f#,10)
12000 last_f = DIMN(fv_array)
12010 last_v = DIMN(fv_array,2)
12020 DIM face_zs(last_f)
12030 FOR i  = 1 TO last_f
12040  face_zs(i) = i
12050 END FOR i
12060 :
12070 pass_by  =  0
12080 REPeat short_sort
12090 pass_by  = pass_by  +  1
12100   swaps = 0
12110   FOR i  = 1 TO last_f - pass_by
12120     IF fq_array(face_zs(i),10) < fq_array(face_zs(i+1),10) THEN
12130       swaps  =  swaps +  1
12140       swap face_zs(i),face_zs(i+1)
12150     END IF
12160   END FOR i
12170   IF NOT(swaps) :  EXIT short_sort
12180 END REPeat short_sort
12190 :
12200 FOR i = 1 TO last_f
12210  ii = face_zs(i)
12220  INK  ink4(ii)
12230  FILL 1
12240  POINT v_array(fv_array(ii,last_v),1),v_array(fv_array(ii,last_v),2)
12250  FOR j = 1  TO last_v
12260   LINE TO v_array(fv_array(ii,j),1),v_array(fv_array(ii,j),2)
12270  END  FOR j
12280  FILL 0
12290 PAUSE 10
12300 END  FOR i
12310 INK  4
12320 END DEFine show_faces
12330 REMark ,,,,,,,,,,,,,,,,,,
12340 :
12350 REMark ''''''''''''''''''''
12360 DEFine PROCedure turn_faces(PS, fv_array, v_array, fq_array)
12370 LOCal  i, j, f, e, v, p, wvfq
12380 REMark make array for manipulation ?
12390 REMark making a working wv_array and a working fq_array [8,9,10]
12400 f = PS_vefpq%(PS,3)   : REMark faces
12410 e = PS_vefpq%(PS,2)   : REMark edges
12420 p = PS_vefpq%(PS,4)   : REMark vertices per face
12430 v = PS_vefpq%(PS,1)   : REMark vertices
12440 :
12450 DIM wv(v,xyz)
12460 FOR i = 0 TO v
12470  FOR  j  =  0 TO xyz
12480   wv(i,j)=v_array(i,j)
12490  END  FOR j
12500 END  FOR i
12510 :
12520 DIM fq(f,xyz)
12530 FOR i = 0 TO f
12540  FOR j = 0  TO  xyz
12550   fq(i,j)=fq_array(i,j+7)
12560  END FOR j
12570 END FOR i
12580 :
12590 DIM fq_tagz%(f-1)
12600 DIM fq_z(f-1)
12610 :
12620 FOR wobble  = 1 TO 32
12630  IF INKEY$==CHR$(27) : EXIT wobble
12640 :
12650  FOR i = 0 TO f-1
12660   fq_z(i) = fq(i+1,3)
12670  END FOR i
12680 :
12690  I_FILL fq_tagz%,0,1
12700  SORT fq_z,1,fq_tagz%
12710 :
12720  CLS
12730  FOR i = 0 TO f-1
12740   ii = 1+fq_tagz%(i)
12750   INK  ink4(ii)
12760   FILL 1
12770   POINT wv(fv_array(ii,p),1),wv(fv_array(ii,p),2)
12780   FOR j = 1  TO p
12790    LINE TO wv(fv_array(ii,j),1),wv(fv_array(ii,j),2)
12800   END  FOR j
12810   FILL 0
12820  END  FOR i
12830  PAUSE  10
12840  INK  4
12850  rotate wv,'x',3
12860  rotate fq,'x',3
12870  rotate wv,'y',5
12880  rotate fq,'y',5
12890  rotate wv,'z',2
12900  rotate fq,'z',2
12910 END FOR wobble
12920 END DEFine turn_faces
12930 REMark ,,,,,,,,,,,,,,,,,,
12940 :
12950 REMark ''''''''''''''''''''
12960 DEFine FuNction space_btwn(xpt,ypt,zpt, x,y,z)
12970 REMark space between two points xpt,ypt,zpt as point of origin
12980 xdis = (x-xpt) : ydis = (y-ypt) : zdis = (z-zpt)
12990 sqdist = ((xdis*xdis)+(ydis*ydis)+(zdis*zdis))
13000 IF sqdist > 0 THEN
13010   sbtw = SQRT(sqdist)
13020   ELSE
13030   sbtw = 0
13040 END IF
13050 RETurn sbtw
13060 RETurn xdis
13070 RETurn ydis
13080 RETurn zdis
13090 END DEFine :REMark FN space_btwn(xpt,ypt,zpt,x,y,z)
13100 REMark ,,,,,,,,,,,,,,,,,,,,
13110 :
13120 REMark '''''''''''''''''''''''''
13130 REMark angl_frm
13140 DEFine FuNction dist_btwn(xpt,ypt,x,y)
13150 REMark distance between two points xpt,ypt as point of origin
13160 xdis = (x-xpt) : ydis = (y-ypt) : sqdist = ((xdis*xdis)+(ydis*ydis))
13170 IF sqdist > 0 THEN
13180   dbtw = SQRT(sqdist)
13190   ELSE
13200   dbtw = 0
13210 END IF
13220 RETurn dbtw
13230 RETurn xdis
13240 RETurn ydis
13250 END DEFine :REMark FN dist_btwn(xpt,ypt,x,y)
13260 REMark ,,,,,,,,,,,,,,,,,,,,
13270 :
13280 REMark '''''''''''''''''''''
13290 DEFine FuNction angl_frm(xf,yf,xt,yt)
13300 REMark angle in degrees from origin(xf,yf) to (xt,yt)
13310 REMark --> = 0 or 360,  = 90, <-- = 180,  = 270
13320 IF dist_btwn(xf,yf,xt,yt) = 0 : PRINT #0;"same spot!" :PAUSE 20:spolangle = 0
13330 qdx=1 :qdy = 2
13340 IF ydis<0 : qdy=qdy+2
13350 IF xdis<0 : qdx=qdx+2
13360 qprd = qdy*qdx  : qsum =qdy+qdx+qprd
13370 quadA = ((INT((qsum+1)/3))/2)
13380 quadB = (quadA-INT(quadA))*5
13390 quad = quadB+quadA  :REMark Trig quadrant I, II, III, or IV
13400 IF dbtw<>0 THEN
13410    sinrat = ydis/dbtw
13420      IF sinrat >  1 THEN sinrat =  1
13430      IF sinrat < -1 THEN sinrat = -1
13440    sangle = DEG(ASIN(sinrat))
13450    SELect ON quad
13460       = 1 :spolangle = sangle
13470       = 2 :spolangle = 180-sangle
13480       = 3 :spolangle = 180-sangle
13490       = 4 :spolangle = 360+sangle
13500       = REMAINDER : PRINT #0;"quad error arcsine":STOP
13510     END SELect
13520  END IF
13530 :
13540 angle_from = spolangle
13550 RETurn angle_from
13560 RETurn quad
13570 END DEFine  :REMark FN angl_frm(xf,yf,xt,yt)
13580 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,
13590 :
13600 REMark ''''''''''''''''''''''''
13610 DEFine PROCedure rotate (array, axis$, degrees)
13620 LOCal i, j, cos_r, sin_r, rot_r, sumin, difin, rota
13630 REMark assumes array with x,y,z coordinates from 0 to dimn(array)
13640 REMark array will be changed, not preserved !
13650 DIM temp(3)
13660 IF axis$ == 'x' : rota = 1
13670 IF axis$ == 'y' : rota = 2
13680 IF axis$ == 'z' : rota = 3
13690 rot_r =  RAD(degrees)
13700 sumin = (rota  MOD (3)) + 1
13710 difin = (sumin MOD (3)) + 1
13720 REMark AT #0, 2,5: PRINT#0;DEG(rot_r);" on ";CHR$(rota + 87);" Axis"
13730 cos_r = COS(rot_r) : sin_r = SIN(rot_r)
13740 FOR i = 0 TO DIMN(array)
13750  temp(rota) = array(i,rota)
13760  temp(sumin) = array(i,sumin)*cos_r + array(i,difin)*sin_r
13770  temp(difin) = array(i,difin)*cos_r - array(i,sumin)*sin_r
13780  FOR j = 1 TO 3
13790   array(i,j) = temp(j)
13800  END FOR j
13810 END FOR i
13820 END DEFine rotate
13830 REMark ,,,,,,,,,,,,,,,,,,,,,,,,
13840 :
13850 REMark ''''''''''''''''''''''''
13860 REMark linesN3space
13870 REMark H L Schaaf
13880 REMark July 21, 1996
13890 REMark 2 lines in 3 space
13900 REMark what is relation of 2 (or more) lines in 3 space ?12900 REMark ref: Graphics Gems I p. 304 Ronald Goldman
13910 :
13920 DEFine PROCedure linesN3space
13930 LOCal i,j,k
13940 :
13950 DIM L3S(2,3,3)
13960 REMark 2 lines, each with 2 points having x,y,z values
13970 REMark use zeroth element for shortest link between lines
13980 REMark L3S(0,0,0) link length is nearest distance between lines
13990 REMark L3S(0,0,[1,2,3]) x,y,z, differences for closest points
14000 REMark L3S(0,1,[1,2,3]) and L3S(0,2,[1,2,3]) are closest points
14010 REMark L3S(0,3,[1,2,3]) direction cosines for link.
14020 REMark direction cosines are same as unit vector values
14030 REMark L3S(0,[1,2,3],0) is cross product of 2 line vectors
14040 REMark L3S(1,0,0) and L3S(2,0,0) are lengths of each line
14050 REMark L3S(1,0,[1,2,3]) and L3S(2,0,[1,2,3]) are x,y,z differences
14060 REMark L3S(1,1,[1,2,3]) and L3S(2,1,[1,2,3]) are 1st point of each line
14070 REMark L3S(1,2,[1,2,3]) and L3S(2,2,[1,2,3]) are 2nd point of each line
14080 REMark L3S(1,3,[1,2,3]) and L3S(2,3,[1,2,3]) are unit vector values
14090 REMark unit vector values are same as direction cosines
14100 REMark L3S(2,3,0) is square of cross product
14110 REMark L3S(2,[1,2],0) are determinants
14120 :
14130 L3S(1,1,1)=P1L1X
14140 L3S(1,1,2)=P1L1Y
14150 L3S(1,1,3)=P1L1Z
14160 L3S(1,2,1)=P2L1X
14170 L3S(1,2,2)=P2L1Y
14180 L3S(1,2,3)=P2L1Z
14190 L3S(2,1,1)=P1L2X
14200 L3S(2,1,2)=P1L2Y
14210 L3S(2,1,3)=P1L2Z
14220 L3S(2,2,1)=P2L2X
14230 L3S(2,2,2)=P2L2Y
14240 L3S(2,2,3)=P2L2Z
14250 FOR i = 1 TO 2
14260  parameterize L3S,i
14270 END FOR i
14280 :
14290 REMark PRINT \ "Cross product Vector --> ",
14300 L3S(0,1,0) = L3S(1,3,2)*L3S(2,3,3)-L3S(2,3,2)*L3S(1,3,3)
14310 L3S(0,2,0) = -(L3S(1,3,1)*L3S(2,3,3)-L3S(2,3,1)*L3S(1,3,3))
14320 L3S(0,3,0) = L3S(1,3,1)*L3S(2,3,2)-L3S(2,3,1)*L3S(1,3,2)
14330 L3S(2,3,0) = 0
14340 FOR i = 1 TO 3
14350  L3S(2,3,0) = L3S(2,3,0) +  L3S(0,i,0)*L3S(0,i,0)
14360 END FOR i
14370 IF L3S(2,3,0) = 0 : PRINT #0;"Lines are parallel" : GO TO 14780
14380 :
14390 REMark find determinants of 3x3 matrices
14400 REMark PRINT\
14410 FOR n = 1,2
14420  nn = 1 + n MOD 2
14430  FOR i = 1 TO 3
14440   L3S(1,i,0) = L3S(2,1,i) - L3S(1,1,i)
14450  END FOR i
14460  L3S(2,n,0) = L3S(2,n,0) + L3S(1,1,0)*L3S(nn,3,2)*L3S(0,3,0)
14470  L3S(2,n,0) = L3S(2,n,0) + L3S(1,2,0)*L3S(nn,3,3)*L3S(0,1,0)
14480  L3S(2,n,0) = L3S(2,n,0) + L3S(1,3,0)*L3S(nn,3,1)*L3S(0,2,0)
14490  L3S(2,n,0) = L3S(2,n,0) - (L3S(1,3,0)*L3S(nn,3,2)*L3S(0,1,0))
14500  L3S(2,n,0) = L3S(2,n,0) - (L3S(1,2,0)*L3S(nn,3,1)*L3S(0,3,0))
14510  L3S(2,n,0) = L3S(2,n,0) - (L3S(1,1,0)*L3S(nn,3,3)*L3S(0,2,0))
14520  :
14530 PRINT "Determinant ";n;" = "; L3S(2,n,0),
14540 END FOR n
14550 :
14560 REMark nearest points and distance
14570 FOR i = 1 TO 3
14580  FOR j = 1 TO 2
14590   L3S(0,j,i) = L3S(j,1,i)+(L3S(2,j,0)/L3S(2,3,0))*L3S(j,3,i)
14600   REMark PRINT L3S(0,j,i),
14610  END FOR j
14620  L3S(0,0,i) = L3S(0,2,i) - L3S(0,1,i)
14630  L3S(0,0,0) = L3S(0,0,0) + (L3S(0,0,i)*L3S(0,0,i))
14640 END FOR i
14650 FOR i = 1 TO 2
14660  PRINT\ "Closest point on Line ";i;" is"
14670  FOR j = 1 TO 3
14680     PRINT L3S(0,i,j),
14690  END FOR j
14700 END FOR i
14710 L3S(0,0,0) = SQRT (L3S(0,0,0))
14720 PRINT\ "Closest Distance is ";L3S(0,0,0)
14730 IF L3S(0,0,0) THEN
14740  parameterize L3S,0
14750 ELSE
14760   PRINT #0; "Lines intersect"
14770 END IF
14780 END DEFine linesN3space
14790 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
14800 :
14810 REMark ''''''''''''''''''''''''
14820 DEFine PROCedure Plane_frm3pts (mat3x3)
14830 LOCal i
14840 DIM EqnPlane(7)
14850 REMark Plane_frm3pts (mat3x3)
14860 REMark a procedure to determine equation of plane in 3 space
14870 REMark given 3 points in array (points, [x,y,z])
14880 REMark in solution of linear form Ax + By + Cz + D = 0
14890 REMark and the normal form  cos_alpha, cos_beta, cos_gamma
14900 REMark and omega the distance from the origin
14910 REMark H L Schaaf
14920 REMark August 16, 1996
14930 :
14940 REMark small errors? +- 2^-30 in SMSQ/E and 2^-30 & 2^-31 in JSU
14950 REMark set some limit near zero
14960 near_zero = 1E-9
14970 REMark 9E-10 is too small !
14980 :
14990 REMark linear form
15000 REMark find A
15010 Ax =      mat3x3(1,2)*mat3x3(2,3)
15020 Ax = Ax + mat3x3(1,3)*mat3x3(3,2)
15030 Ax = Ax + mat3x3(2,2)*mat3x3(3,3)
15040 Ax = Ax - mat3x3(1,2)*mat3x3(3,3)
15050 Ax = Ax - mat3x3(1,3)*mat3x3(2,2)
15060 Ax = Ax - mat3x3(3,2)*mat3x3(2,3)
15070 REMark IF ABS(Ax)<near_zero :PRINT "Ax=";Ax:Ax = 0
15080 IF ABS(Ax)<near_zero : Ax = 0
15090 :
15100 REMark find B
15110 By =      mat3x3(1,1)*mat3x3(2,3)
15120 By = By + mat3x3(1,3)*mat3x3(3,1)
15130 By = By + mat3x3(2,1)*mat3x3(3,3)
15140 By = By - mat3x3(1,3)*mat3x3(2,1)
15150 By = By - mat3x3(2,3)*mat3x3(3,1)
15160 By = By - mat3x3(3,3)*mat3x3(1,1)
15170 By = - By
15180 REMark IF ABS(By)<near_zero :PRINT "By=";By:By = 0
15190 IF ABS(By)<near_zero : By = 0
15200 :
15210 REMark find C
15220 Cz =      mat3x3(1,1)*mat3x3(2,2)
15230 Cz = Cz + mat3x3(1,2)*mat3x3(3,1)
15240 Cz = Cz + mat3x3(2,1)*mat3x3(3,2)
15250 Cz = Cz - mat3x3(1,2)*mat3x3(2,1)
15260 Cz = Cz - mat3x3(3,1)*mat3x3(2,2)
15270 Cz = Cz - mat3x3(3,2)*mat3x3(1,1)
15280 REMark IF ABS(Cz)<near_zero :PRINT "Cz=";Cz:Cz = 0
15290 IF ABS(Cz)<near_zero : Cz = 0
15300 :
15310 REMark find D
15320 Dp =      (mat3x3(1,1)*mat3x3(2,2)*mat3x3(3,3))
15330 Dp = Dp + (mat3x3(1,2)*mat3x3(2,3)*mat3x3(3,1))
15340 Dp = Dp + (mat3x3(1,3)*mat3x3(2,1)*mat3x3(3,2))
15350 Dp = Dp - (mat3x3(1,1)*mat3x3(2,3)*mat3x3(3,2))
15360 Dp = Dp - (mat3x3(1,2)*mat3x3(2,1)*mat3x3(3,3))
15370 Dp = Dp - (mat3x3(1,3)*mat3x3(2,2)*mat3x3(3,1))
15380 Dp = - Dp
15390 REMark IF ABS(Dp)<near_zero :PRINT "Dp=";Dp:Dp = 0
15400 IF ABS(Dp)<near_zero : Dp = 0
15410 :
15420 IF ((Ax = 0)AND(By = 0)AND(Cz = 0)) THEN PRINT #0;"3 points in a line ": STOP
15430 :
15440 REMark get the normal form
15450 Nd = SQRT(Ax*Ax + By*By +Cz*Cz)
15460 IF Dp>0 THEN Nd = - Nd
15470 cos_alpha = Ax/Nd
15480 cos_beta  = By/Nd
15490 cos_gamma = Cz/Nd
15500 omega = -Dp/Nd
15510 EqnPlane(0) = omega
15520 EqnPlane(1) = cos_alpha
15530 EqnPlane(2) = cos_beta
15540 EqnPlane(3) = cos_gamma
15550 REMark start with a positive value for x
15560 EqnPlane(4) = Ax
15570 EqnPlane(5) = By
15580 EqnPlane(6) = Cz
15590 EqnPlane(7) = Dp
15600 REMark start with a positive value for first non-zero term x  ?
15610 IF (Ax < 0 ) : FOR i = 4 TO 7 : EqnPlane(i) = - EqnPlane(i) : END FOR i
15620 REMark if  Ax = 0 then start with positive value for y
15630 IF ((Ax = 0) AND (By<0)) : FOR i = 5 TO 7 : EqnPlane(i) = - EqnPlane(i) : END FOR i
15640 REMark if  Ax = 0 ad By = 0 then start with positive value for z
15650 IF ((Ax=0) AND (By=0) AND (Cz<0)) : FOR i = 6 TO 7 : EqnPlane(i) = - EqnPlane(i) : END FOR i
15660 END DEFine Plane_frm3pts
15670 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,
15680 :
15690 REMark ''''''''''''''''''''''''''
15700 DEFine PROCedure parameterize(A,n)
15710 REMark A is Array for line having 2 points, each with x,y,z values
15720 LOCal ii
15730 A(n,0,0) = 0
15740 FOR ii = 1 TO 3
15750  REMark get differences in x,y,z values
15760  A(n,0,ii) = A(n,2,ii)-A(n,1,ii)
15770  REMark sum the squares and store in A(n,0,0)
15780  A(n,0,0) = A(n,0,0) + (A(n,0,ii) * A(n,0,ii))
15790  REMark PRINT ii, a(n,0,0)
15800 END FOR ii
15810 REMark distance in space between points
15820 A(n,0,0) = SQRT(A(n,0,0))
15830 IF A(n,0,0) = 0 : PRINT "parameterized Line ";n;" has no length !": review_L3S : PAUSE 30 : GO TO 15880 :REMark STOP
15840 FOR ii = 1 TO 3
15850  REMark get direction cosines = unit vector values
15860  A(n,3,ii) = A(n,0,ii)/A(n,0,0)
15870 END FOR ii
15880 END DEFine parameterize
15890 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
15900 :
15910 REMark '''''''''''''''''''''''''
15920 DEFine PROCedure review_L3S
15930 LOCal i,j,k
15940 FOR i = 0 TO 2
15950  PRINT \"Line ";i
15960  FOR j = 0 TO 3
15970   REMark PRINT j,
15980   FOR k = 0 TO 3
15990    PRINT L3S(i,j,k),
16000   END FOR k
16010   PRINT
16020  END FOR j
16030 END FOR i
16040 END DEFine review_L3S
16050 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
16060 :
16070 REMark '''''''''''''''''''''''''''
16080 DEFine PROCedure swap (n1,n2)
16090 n1 = n1 + n2
16100 n2 = n1 - n2
16110 n1 = n1 - n2
16120 END DEFine swap
16130 REMark ,,,,,,,,,,,,,,,,,,,,,,
16140 :
16150 REMark '''''''''''''''''''''''''
16160 DEFine FuNction cyc (Number%,cycle_length%)
16170 REMark cyclic modular with option base = 1 vs option base 0
16180 REMark Number% is an integer number,  cycle_length% is the Length of the cycle
16190 RETurn ((Number%-1) MOD cycle_length%)+1
16200 END DEFine cyc
16210 REMark ,,,,,,,,,,,,,,,,,,,,,,,
16220 :
16230 REMark '''''''''''''''''''''''''
16240 DEFine FuNction DMS(radians)
16250 REMark returns Degrees, Minutes, Seconds given Radians
16260 Dg = DEG(radians)
16270 Mn = 60 *(Dg - INT(Dg))
16280 Dg = INT(Dg)
16290 Sc = 60 *(Mn - INT(Mn))
16300 Mn = INT (Mn)
16310 RETurn Dg
16320 RETurn Mn
16330 RETurn Sc
16340 END DEFine DMS
16350 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,
16360 :
16370 REMark '''''''''''''''''''''''''
16380 DEFine PROCedure show_DMS(radian)
16390 Dg = DMS(radian)
16400 PRINT radian;' Radians = ';Dg;' ';Mn;"' ";Sc;'"'
16410 END DEFine show_DMS
16420 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,
16430 :
16440 REMark ''''''''''''''''''''''''
16450 DEFine FuNction SGN(n)
16460   RETurn (n>0) - (n<0)
16470 END DEFine SGN
16480 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,
16490 :
16500 REMark '''''''''''''''''''''''''''''''
16510 DEFine FuNction Pt_to_plane (x,y,z, Ax, By, Cz, Dp)
16520 REMark here we need a general way to find distance from point
16530 REMark to plane in 3 space
16540 REMark given the x,y,z, and  coefficients of the form:
16550 REMark AX + By + Cz + Dp = 0
16560 SignC = SGN(Cz)
16570 IF SignC = 0 : SignC = 1
16580 PTP = (Ax*x + By*y + Cz*z + Dp)/(SignC*SQRT(Ax*Ax+By*By+Cz*Cz))
16590 RETurn PTP
16600 END DEFine Pt_to_plane
16610 REMark ,,,,,,,,,,,,,,,,,,,,,,
16620 :
16630 REMark ''''''''''''''''''''''
16640 DEFine PROCedure get_vertices (Platonic_Solid)
16650 LOCal i,j
16660 FOR i = 1 TO DIMN(Platonic_Solid)
16670   FOR j = 1 TO 3
16680     READ Platonic_Solid(i,j)
16690     REMark PRINT Platonic_Solid(i,j),
16700   END FOR j
16710 END FOR i
16720 END DEFine get_vertices
16730 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,
16740 REMark ''''''''''''''''''''''''''''''''''
16750 DEFine PROCedure get_edges (eva, va, edge_length)
16760  REMark find which pairs of vertices make up the edges
16770  LOCal i, j, k, c
16780  REMark PRINT \ edge_length
16790  c = 0
16800  FOR i = 1 TO DIMN(va)-1
16810   FOR j = i + 1 TO DIMN(va)
16820    REMark PRINT i,j, space_btwn(va(i,1),va(i,2),va(i,3),va(j,1),va(j,2),va(j,3))
16830    IF (edge_length == space_btwn(va(i,1),va(i,2),va(i,3),va(j,1),va(j,2),va(j,3))) THEN
16840      c = c + 1
16850      eva(c,1) = i : eva(c,2) = j
16860      REMark    PRINT "edge#";c,eva(c,1),eva(c,2)
16870    END IF
16880   END FOR j
16890  END FOR i
16900 END DEFine get_edges
16910 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,
16920 :
16930 REMark '''''''''''''''''''''''''''''
16940 DEFine PROCedure get_vertex_to_edges(vea, va, eva)
16950  LOCal i, j
16960  FOR i = 1 TO DIMN(va)
16970   FOR j = 1 TO DIMN(eva)
16980    IF ((eva(j,1)== i) OR (eva(j,2) == i))  THEN
16990     vea(i,0) = vea(i,0) + 1
17000     vea(i,vea(i,0))=j
17010    END IF
17020   END FOR j
17030  END FOR i
17040 END DEFine get_vertex_to_edges
17050 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
17060 :
17070 REMark  ''''''''''''''''''''''''''''
17080 DEFine PROCedure get_faces( fva, fea, efa, vfa, va, eva, vea, fqa )
17090 LOCal i, j, k, kk, V1, V2, V3, f
17100 maxPTP = 0
17110 REMark fva%is face to vertices array (given face, lists vertices)
17120 REMark fea is face to edges array   fea(Face#,edges per face)
17130 REMark efa is edge to faces array   efa(Edge#,2)
17140 REMark vfa is vertex to faces array vfa(Vertex#,edges per vertex)
17150 REMark va%is vertex to x,y,z values array (Vertex#, [x,y,z])
17160 REMark eva%is edge to vertices array  eva(edge#,2)
17170 REMark vea is vertex to edges array   vea(vertice#,edges per vertex)
17180 REMark fqa is faces to equation of plane array
17190 REMark fqa(face,[0,1,2,3] for omega, cos_alpha, cos_beta, cos_gamma
17200 REMark fqa(face,[4,5,6,7] for Ax, By, Cz, Dp
17210 REMark fqa(0,[1 to 7] used as register for comparing
17220 REMark and fqa [8, 9, 10]  =  x, y, z for center of face
17230 :
17240 REMark take any two edges which have common vertex
17250 REMark and solve for the equation of the plane
17260 REMark look for all other vertices in that plane
17270 REMark find center point of those vertices, which should
17280 REMark be the center of a face.
17290 REMark and be at the inscribed radius.
17300 REMark order the points by angle from center
17310 REMark create ordered face_vertices list
17320 REMark and ordered face_edges list, linking edges in order
17330 REMark order meaning counterclockwise viewed from outside the solid
17340 REMark find which edges make up the faces
17350 REMark ah-ha ! we find extra planes !
17360 REMark need to see that angle between edges is proper as well .
17370 REMark the angle being pi -(2*pi/(number of edges/face))
17380 REMark (1 - 2/edges)*pi
17390 REMark so how about a FuNction for angle between lines in space ?
17400 REMark simply get direction cosines for each line
17410 REMark paying attention to direction !
17420 REMark and multiply to find face angle cos_theta
17430 :
17440 REMark parameterize the two lines and get dot.product ?
17450 :
17460 f = 0  : REMark keep track of faces
17470 REMark try all pairs of edges against each other
17480 FOR i = 1 TO DIMN(eva) - 1
17490   FOR j = i + 1 TO DIMN(eva)
17500     REMark PRINT\ i,j,
17510     V1 = 0 : V2 = 0 : V3 = 0
17520     REMark see if two edges i and j have a vertex in common
17530     IF eva(i,1)=eva(j,1) :V3 = eva(j,2) :V2 = eva(i,1) :V1 = eva(i,2)
17540     IF eva(i,2)=eva(j,1) :V3 = eva(j,2) :V2 = eva(i,2) :V1 = eva(i,1)
17550     IF eva(i,2)=eva(j,2) :V3 = eva(j,1) :V2 = eva(i,2) :V1 = eva(i,1)
17560     IF eva(i,1)=eva(j,2) :V3 = eva(j,1) :V2 = eva(i,1) :V1 = eva(i,2)
17570 :
17580 REMark if no match then try another j loop
17590 :
17600     IF ((V1+V2+V3) = 0) : NEXT j : EXIT j
17610 :
17620     DIM DCOS(2,3) : REMark direction cosines
17630     REMark    PRINT #0\"two edges with common vertex",
17640     REMark V2 is common vertex
17650 REMark order V3 and V1 so V1 is lower number ? for PS = 4 ?
17660 REMark not needed
17670 REMark IF ((PS = 4)OR (PS = 6)) : IF (V1 > V2) : swap V1,V2
17680 REMark IF ((PS = 4)) : IF (V1 > V2) : swap V1,V2
17690     REMark    PRINT #0;"possible face",V1,V2,V3,
17700     DIM P3P(3,3)
17710     FOR k = 1 TO 3
17720        P3P(1,k) = va(V1,k)
17730        P3P(2,k) = va(V2,k)
17740        P3P(3,k) = va(V3,k)
17750     END FOR k
17760     REMark get direction cosines for both edges
17770     line_n3space P3P(2),P3P(1)
17780     FOR k = 1 TO 3
17790        DCOS(1,k)= Al3s(0,k)
17800     END FOR k
17810     line_n3space P3P(2),P3P(3)
17820     FOR k = 1 TO 3
17830        DCOS(2,k)= Al3s(0,k)
17840     END FOR k
17850     FOR k = 1 TO 3
17860        DCOS(0,k)=DCOS(1,k)*DCOS(2,k)
17870        DCOS(0,0) = DCOS(0,0)+DCOS(0,k)
17880     END FOR k
17890 :
17900      IF ((INT((2*PI)/(PI-ACOS(DCOS(0,0))))) <> PS_vefpq%(PS,4)) : NEXT j : EXIT j
17910     REMark check that PS_vefpq%(ps,4) is number of edges per face
17920     Plane_frm3pts P3P
17930     FOR k = 0 TO 7
17940       fqa(0,k)=EqnPlane(k)
17950     END FOR k
17960 :
17970     REMark test for new plane or match_up to old one
17980     DIM match(DIMN(fqa))
17990     FOR k = 1 TO DIMN(fqa)
18000        FOR kk = 0 TO 7
18010          match(k) = match(k) + ((fqa(0,kk)+1) == (fqa(k,kk)+1))
18020        END FOR kk
18030      IF (match(k) == 8) : match(0) = k : EXIT k
18040        REMark an old plane; try another j loop
18050     END FOR k
18060     IF match(0) : NEXT j : EXIT j
18070     IF (NOT(match(0))) THEN
18080       f = f + 1
18090 IF f > DIMN(fqa) : PRINT #0;"f > DIMN(fqa) ",f;" > ";DIMN(fqa): STOP
18100       PRINT #0;"face #";f;" = vertices ",
18110       FOR kk = 0 TO 7
18120         fqa(f,kk) = fqa(0,kk) : fqa(0,kk) = 0
18130       END FOR kk
18140       REMark now test all vertices for being in the plane
18150       FOR k = 1 TO DIMN(va)
18160         PTP = Pt_to_plane (va(k,1), va(k,2), va(k,3), fqa(f,4), fqa(f,5), fqa(f,6), fqa(f,7))
18170         IF (ABS(PTP) < 2E-9) THEN
18180            REMark presume we've found a point in the plane
18190            fva(f,0) = fva(f,0)+1
18200            fva(f,fva(f,0)) = k
18210            PRINT #0;k,
18220         END IF
18230       END FOR k
18240       PRINT #0;
18250       IF fva(f,0) <> DIMN(fva(2)) THEN PRINT#0; " Missing ";DIMN(fva(2))-fva(f,0);" vertices !";' for face #';f :PAUSE
18260      END IF
18270   END FOR j
18280 END FOR i
18290 :
18300 :
18310 IF f <> DIMN(fva) : PRINT #0;"Didn't get all ";DIMN(fva);" faces ! Missing ";DIMN(fva) - f;' faces' :PAUSE
18320 :
18330 PRINT #0 ;"Ordering vertices and edges for faces"
18340 :
18350 FOR i = 1 TO DIMN(fva)
18360 REMark make a working array for each face
18370 DIM worka(DIMN(fva,2),3)
18380 FOR j = 1 TO DIMN(fva,2)
18390 FOR k = 1 TO 3
18400 worka(j,k) = va(fva(i,j),k)
18410 worka(0,k) = worka(0,k) + worka(j,k)
18420 END FOR k
18430 END FOR j
18440 CLS
18450 INK ink4(4)
18460 REMark show_face worka
18470 :
18480 REMark now find the center of the face
18490 REMark and put it in fqa
18500 REMark PRINT  "Center of face ";i,DIMN(fva,2)
18510 INK ink4(6)
18520 REMark LINE 0,-10 TO 0,10
18530 REMark LINE -10,0 TO 10,0
18540 FOR j = 1 TO 3
18550 worka(0,j) = worka(0,j)/DIMN(fva,2)
18560 REMark PRINT worka(0,j),
18570 fqa(i,j+7) = worka(0,j)
18580 END FOR j
18590 GO TO 18650
18600 INK ink4(2)
18610 CIRCLE 0,0,2E-2
18620 LINE 0,0 TO worka(0,1),worka(0,2)
18630 show_face worka
18640 PAUSE 30
18650 :
18660 REMark now rotate about x axis by some amount of y
18670 REMark so as to center face at y = 0
18680 REMark look at it on yz plane
18690 rot_x = -angl_frm (0,0,worka(0,3),worka(0,2))
18700 rotate worka, 'x', rot_x
18710 GO TO 18800
18720 INK ink4(4)
18730 show_face worka
18740 INK 2
18750 LINE 0,0 TO worka(0,1),worka(0,2)
18760 INK ink4(6)
18770 CIRCLE worka(0,1),worka(0,2),4E-2
18780 REMark PAUSE
18790 :
18800 REMark now rotate about y axis by some amount of x
18810 REMark so as to center at x = 0
18820 REMark look at it on xz plane
18830 rot_y = angl_frm(0,0,worka(0,3),worka(0,1))
18840 rotate worka, 'y', rot_y
18850 :
18860 INK 4
18870 show_face worka
18880 INK ink4(2)
18890 LINE 0,0 TO worka(0,1),worka(0,2)
18900 CIRCLE 0,0,2E-2
18910 INK ink4(6)
18920 CIRCLE worka(0,1),worka(0,2),4E-2
18930 REMark PAUSE
18940 :
18950 CLS
18960 INK ink4(4)
18970 show_face worka
18980 INK ink4(2)
18990 LINE 0,0 TO worka(0,1),worka(0,2)
19000 CIRCLE 0,0,2E-2
19010 INK ink4(6)
19020 CIRCLE worka(0,1),worka(0,2),4E-2
19030 :
19040 REMark PAUSE
19050 REMark then can check bearings and sort out vertices & linking edges
19060 DIM bear_list(DIMN(fva,2))
19070 FOR j = 1 TO DIMN(fva,2)
19080 bear_list(j)= angl_frm(0,0,worka(j,1),worka(j,2))
19090 LINE 0,0 TO worka(j,1),worka(j,2)
19100 REMark PRINT bear_list(j)
19110 END FOR j
19120 REMark now sort them out by size
19130 :
19140 REPeat dumbsort
19150 swaps = 0
19160 FOR j = 2 TO DIMN(fva,2)
19170 IF bear_list(j-1)>bear_list(j) THEN
19180 swaps = swaps + 1
19190 swap bear_list(j-1),bear_list(j)
19200 swap fva(i,j-1),fva(i,j)
19210 FOR k = 1 TO 3
19220 swap worka(j-1,k),worka(j,k)
19230 END FOR k
19240 END IF
19250 END FOR j
19260 IF swaps = 0 : EXIT dumbsort
19270 END REPeat dumbsort
19280 :
19290  REMark PAUSE
19300 CLS
19310 show_face worka
19320 REMark put the face back where it was
19330 rotate worka, 'y', -rot_y
19340 rotate worka, 'x', -rot_x
19350 REMark show where it came from
19360 INK ink4(2)
19370 show_face worka
19380 AT 0,0: PRINT PS_name$(PS);" Face ";i
19390 IF PS = 6 : AT 1,0: PRINT "Set ";set;", Tetrahedra ";tet
19400 :
19410  PAUSE 10
19420 :
19430 :
19440 REMark  link face to edges  fea  from fva and vea
19450 REMark and get v to f and e to f links vfa, efa
19460 REMark we're dealing with face i
19470 INK ink4(4)
19480 FOR j = 1 TO DIMN(fva,2)
19490 vfa(fva(i,j),0) = vfa(fva(i,j),0)+ 1
19500 vfa(fva(i,j),vfa(fva(i,j),0))= i
19510 :
19520 REMark j points to vertex va(fva(i,j))
19530 jj = cyc ((j + 1),DIMN(fva,2))
19540 REMark jj points to the next vertex va(fva(i,jj))
19550 REMark now what edge matches this ?
19560 FOR k = 1 TO DIMN(eva)
19570 REMark the matching edge will be k
19580 IF ((eva(k,1)= fva(i,j) AND eva(k,2)= fva(i,jj)) OR                       (eva(k,2)= fva(i,j) AND eva(k,1)= fva(i,jj))) THEN
19590 fea(i,0) = fea(i,0) + 1
19600 fea(i,j) = k
19610 POINT  va(eva(k,1),1),va(eva(k,1),2)
19620 LINE TO  va(eva(k,2),1),va(eva(k,2),2)
19630  :
19640 REMark get edge to faces link
19650 efa(k,0)=efa(k,0)+1
19660 efa(k,efa(k,0)) = i
19670  :
19680 END IF
19690 END FOR k
19700 END FOR j
19710 :
19720 PAUSE 10
19730 :
19740 END FOR i
19750 CLS
19760 :
19770 END DEFine get_faces
19780 :
19790 :
19800 :
19810 REMark ''''''''''''''''''''''
19820 REMark review_links PS
19830 DEFine PROCedure review_links (PS,va,vea,vfa,eva,efa,fva,fea,fqa)
19840 LOCal i, j
19850 INK ink4(PS)
19860 PRINT\ PS_name$(PS);' vertices'
19870 PRINT "V#",,"X","Y","Z"
19880 FOR i = 0 TO PS_vefpq%(PS,1)
19890 PRINT\ i,
19900 FOR j = 0 TO 3
19910 PRINT va(i,j),
19920 END FOR j
19930 END FOR i
19940 PAUSE 10
19950 :
19960 PRINT\ PS_name$(PS);' vertices to edges'
19970 FOR i = 0 TO PS_vefpq%(PS,1)
19980 PRINT\ i,
19990 FOR j = 0 TO PS_vefpq%(PS,5)
20000 PRINT vea(i,j),
20010 END FOR j
20020 END FOR i
20030 PAUSE 10
20040 :
20050 PRINT\ PS_name$(PS);' vertices to faces'
20060 FOR i = 0 TO PS_vefpq%(PS,1)
20070 PRINT\ i,
20080 FOR j = 0 TO PS_vefpq%(PS,5)
20090 PRINT vfa(i,j),
20100 END FOR j
20110 END FOR i
20120 PAUSE 10
20130 :
20140 PRINT\ PS_name$(PS);' edges to vertices'
20150 FOR i = 0 TO PS_vefpq%(PS,2)
20160 PRINT\ i,
20170 FOR j = 0 TO 2
20180 PRINT eva(i,j),
20190 END FOR j
20200 END FOR i
20210 PAUSE 10
20220 :
20230 PRINT\ PS_name$(PS);' edges to faces'
20240 FOR i = 0 TO PS_vefpq%(PS,2)
20250 PRINT\ i,
20260 FOR j = 0 TO 2
20270 PRINT efa(i,j),
20280 END FOR j
20290 END FOR i
20300 PAUSE 10
20310 :
20320 PRINT\ PS_name$(PS);' face to vertices'
20330 FOR i = 0 TO PS_vefpq%(PS,3)
20340 PRINT\ i,
20350 FOR j = 0 TO PS_vefpq%(PS,4)
20360 PRINT fva(i,j),
20370 END FOR j
20380 END FOR i
20390 PAUSE 10
20400 :
20410 PRINT\ PS_name$(PS);' face to edges'
20420 FOR i = 0 TO PS_vefpq%(PS,3)
20430 PRINT\ i,
20440 FOR j = 0 TO PS_vefpq%(PS,4)
20450 PRINT fea(i,j),
20460 END FOR j
20470 END FOR i
20480 PAUSE 10
20490 :
20500 :
20510 PRINT\ "Equation of planes for ";PS_name$(PS)
20520 REMark fqa(face,[0,1,2,3] for omega, cos_alpha, cos_beta, cos_gamma
20530 REMark fqa(face,[4,5,6,7] for Ax, By, Cz, Dp
20540 PRINT "plane#, omega, cos_alpha, cos_beta, cos_gamma, Ax, By, Cz, Dp"
20550 FOR i = 0 TO DIMN(fqa)
20560   PRINT \ i,
20570   FOR j = 0 TO 10
20580     PRINT fqa(i,j);'  ';
20590   END FOR j
20600 END FOR i
20610 PRINT
20620 PAUSE 10
20630 :
20640 END DEFine review_links
20650 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
20660 :
20670 REMark '''''''''''''''''''''''''''''
20680 DEFine PROCedure show_face (array)
20690 LOCal i
20700 POINT array(1,1),array(1,2)
20710 FOR i = 2 TO DIMN(array)
20720   LINE TO array(i,1),array(i,2)
20730 END FOR i
20740 LINE TO array(1,1),array(1,2)
20750 END DEFine show_face
20760 :
20770 REMark ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
20780 :
20790 REMark make_struts t_v,t_fq,t_ev%,t_fv%,t_sv,t_sev%
20800 REMark DEFine PROCedure make_struts (va,fqa,eva,fva,sva,seva)
20810 REMark face by face ?
20820 REMark need strut width s_w? as % of distance from center to vertex ?
20830 REMark center of each face from fqa(i,[8 to 10])
20840 REMark ordered vertices from fva
20850 REMark ordered edges from fea
20860 REMark from first fva #1 vertex by s_w towards center establishes sva 1
20870 REMark first fva #1 vertex becomes sva 2
20880 REMark next fva #2 vertex becomes sva 3
20890 REMark from sva 3 by s_w towards center sets sva 4
20900 REMark
20910 REMark now do again, starting with fva #2
20920 REMark repeat until cycle for face is complete
20930 REMark fva 1 to vpf, and fva 2 to (vpf+1) cyc vpf
20940 :
20950 REMark we should have strut array ? strut(edges,2)
20960 REMark or trapz to face, face to trapz links ?
20970 REMark assign strut # as = edge that is sva 2-3
20980 REMark
20990 :
21000 REMark ....................
21010 DEFine PROCedure get_PS_nums(PS)
21020 vertices = PS_vefpq%(PS,1)
21030 edges = PS_vefpq%(PS,2)
21040 faces = PS_vefpq%(PS,3)
21050 REMark Schlafli p is vertices (and edges) per face
21060 REMark might rename this as vepf
21070 p = PS_vefpq%(PS,4)
21080 REMark Schlafli q is faces (and edges) per vertex
21090 REMark might rename this as fepv
21100 q = PS_vefpq%(PS,5)
21110 END DEFine get_PS_nums
21120 REMark ,,,,,,,,,,,,,,,,,,,,
21130 :
21140 :
21150 REMark ...............
21160 DEFine PROCedure revolve (edge_links, vert_ices)
21170 LOCal i,j
21180  REMark preserve called array by making a working array
21190  DIM work_array(DIMN(vert_ices),xyz)
21200  FOR i = 0 TO DIMN(vert_ices)
21210    FOR j = 1 TO xyz
21220      work_array(i,j) = vert_ices(i,j)
21230    END FOR j
21240  END FOR i
21250  :
21260  FOR wobble  = 1 TO 32
21270  IF INKEY$==CHR$(27) : EXIT wobble
21280  CLS
21290  show_edges edge_links,work_array
21300  rotate work_array,'x',3
21310  REMark PAUSE
21320  CLS
21330  show_edges edge_links,work_array
21340  rotate work_array,'y',5
21350  REMark PAUSE
21360  REMark CLS
21370  REMark show_edges edge_links,work_array
21380  REMark rotate work_array,'z',2
21390  REMark PAUSE
21400  REMark CLS
21410  END FOR wobble
21420  END DEFine revolve
21430 REMark ,,,,,,,,,,,,,,,,,,,
21440  :
21450 REMark ...................
21460 DEFine PROCedure make_struts(va,fqa,eva,fva,_sva,s_eva)
21470  LOCal i,j,k
21480  CLS
21490  :
21500  REMark put original vertices in
21510  INK ink4(7)
21520  FOR i = 1 TO vertices
21530    FOR j = 1 TO xyz
21540      _sva(i,j) = va(i,j)
21550    END FOR j
21560  POINT _sva(i,1),_sva(i,2)
21570  END FOR i
21580  :
21590  REMark show face centers
21600   INK ink4(2)
21610   FOR i = 1 TO faces
21620     POINT fqa(i,8),fqa(i,9)
21630   END FOR i
21640  :
21650  REMark interpolate inner vertices for each outer face &vertex combo
21660  INK ink4(4)
21670  REMark for each face
21680  i_j = vertices
21690  FOR i = 1 TO faces
21700    face_num = i
21710    REMark for the p vertices that go with that face
21720      FOR j = 1 TO p
21730        i_j = i_j + 1
21740        vert_num = fva(i,j)
21750        _sva(i_j,0) = i
21760        PRINT#0; "sv# ";i_j,"face ";face_num,"vertex ";vert_num
21770  REMark     PAUSE
21780  REMark interpolate the xyz values
21790        FOR k = 1 TO xyz
21800          _sva(i_j,k)=interp(_sva(vert_num,k),fqa(i,k+7),strut_width)
21810        END FOR k
21820        POINT _sva(i_j,1),_sva(i_j,2)
21830        LINE _sva(vert_num,1),_sva(vert_num,2) TO _sva(i_j,1),_sva(i_j,2)
21840      END FOR j
21850  END FOR i
21860  :
21870  REMark now get edges
21880  REMark pick up the matching original edges
21890  INK ink4(6)
21900  FOR i = 1 TO edges
21910    REMark only 2 vertices per edge
21920    FOR j = 1 TO 2
21930      s_eva(i,j) = eva(i,j)
21940    END FOR j
21950    LINE _sva(s_eva(i,1),1),_sva(s_eva(i,1),2) TO                              _sva(s_eva(i,2),1),_sva(s_eva(i,2),2)
21960  END FOR i
21970  :
21980  REMark now build remaining edge to vertex list
21990  REMark INK 2
22000 REMark bring index back to 2*p; i_o1 = (starting i - 2*p)
22010  i_o1 = edges + 1 - (2*p)
22020  REMark also need index so first sv is ~ (i div 2)+ i_o2
22030  i_o2 = (vertices + 1)- ((edges+1) DIV 2)
22040  REMark also need index so first chord is tied to first se_edge
22050  i_o3 = (vertices+1)-((edges+2)/2)
22060 REMark PRINT "index offsets are ",i_o1,i_o2,i_o3
22070  FOR i = (edges+1) TO DIMN(s_eva)
22080  face_num =  (i - i_o1) DIV (2*p)
22090     s_eva(i,0) = face_num
22100 REMark is it the last edge on that face ?
22110     last_edge = NOT((i-edges) MOD (2*p))
22120     radial = i MOD 2
22130     IF radial THEN
22140        INK ink4(2)
22150        PRINT#0; 'radial',
22160        v_n = cyc (((i - i_o1 +1)/2), p)
22170        s_eva(i,1) = fva(face_num,v_n)
22180        s_eva(i,2) = (i DIV 2) + i_o2
22190        CIRCLE _sva(s_eva(i,1),1),_sva(s_eva(i,1),2),.1
22200     ELSE
22210       INK 4
22220       PRINT#0; 'chord',
22230       s_eva(i,1) = (i/2) + i_o3
22240       s_eva(i,2) = s_eva(i,1) + 1
22250       IF last_edge : s_eva(i,2)=s_eva(i,2)- p
22260     END IF
22270        PRINT #0;i,"from ";s_eva(i,1);" to ";s_eva(i,2),"face# ";s_eva(i,0)
22280        LINE _sva(s_eva(i,1),1),_sva(s_eva(i,1),2) TO                              _sva(s_eva(i,2),1),_sva(s_eva(i,2),2)
22290  REMark PAUSE
22300  END FOR i
22310  :
22320  REMark still need to link edges, struts, and trapezoidal polygons
22330  :
22340  :
22350  INK 2
22360  show_edges s_eva,_sva
22370  REMark  PAUSE
22380  INK ink4(4)
22390  show_edges eva,va
22400  END DEFine make_struts
22410 REMark ,,,,,,,,,,,,,,,
22420  :
22430 REMark ................
22440  DEFine FuNction interp(starting,ending,ratio)
22450  REMark interpolates between two values by a ratio
22460  REMark ratio usually from 0 to 1, could try other values
22470  RETurn starting + (ending - starting) * ratio
22480  END DEFine interp
22490 REMark ,,,,,,,,,,,,,,,,,,,,,,
22500  :
22510 :
22520 REMark end of Procedures and Functions
22530 REMark .......................................................
22540 :
22550 :
22560 REMark -------------------------------------------------------------
22570 REMark beginning of DATA statements
22580 :
22590 REMark data for dodecahedron vertices follows:
22600 REMark edge length of 2 * itau
22610 DATA tau, 0, itau   : REMark d1
22620 DATA tau, 0, -itau  : REMark d2
22630 DATA -tau, 0, itau  : REMark d3
22640 DATA -tau, 0, -itau : REMark d4
22650 DATA 0, itau, tau   : REMark d5
22660 DATA 0, itau, -tau  : REMark d6
22670 DATA 0, -itau, tau  : REMark d7
22680 DATA 0, -itau, -tau : REMark d8
22690 DATA itau, tau, 0   : REMark d9
22700 DATA itau, -tau, 0  : REMark d10
22710 DATA -itau, tau, 0  : REMark d11
22720 DATA -itau, -tau, 0 : REMark d12
22730 DATA 1, 1, -1       : REMark d13
22740 DATA 1, 1, 1        : REMark d14
22750 DATA 1, -1, -1      : REMark d15
22760 DATA 1, -1, 1       : REMark d16
22770 DATA -1, 1, -1      : REMark d17
22780 DATA -1, 1, 1       : REMark d18
22790 DATA -1, -1, -1     : REMark d19
22800 DATA -1, -1, 1      : REMark d20
22810 :
22820 REMark data for icosahedron vertices follows:
22830 REMark edge length of 2
22840 DATA tau, 1, 0      : REMark i1
22850 DATA -tau, 1, 0     : REMark i2
22860 DATA tau, -1, 0     : REMark i3
22870 DATA -tau, -1, 0    : REMark i4
22880 DATA 1, 0, tau      : REMark i5
22890 DATA 1, 0, -tau     : REMark i6
22900 DATA -1, 0, tau     : REMark i7
22910 DATA -1, 0, -tau    : REMark i8
22920 DATA 0, tau, 1      : REMark i9
22930 DATA 0, tau, -1     : REMark i10
22940 DATA 0, -tau, 1     : REMark i11
22950 DATA 0, -tau, -1    : REMark i12
22960 :
22970 REMark data for tetrahedron vertices follows:
22980 REMark edge length of 2 * sqrt(2)
22990 DATA 1, 1, 1        : REMark t1
23000 DATA 1, -1, -1      : REMark t2
23010 DATA -1, 1, -1      : REMark t3
23020 DATA -1, -1, 1      : REMark t4
23030 :
23040 REMark data for alternate tetrahedron vertices:
23050 DATA 1, 1, -1       : REMark t1a
23060 DATA 1, -1, 1       : REMark t2a
23070 DATA -1, 1, 1       : REMark t3a
23080 DATA -1, -1, -1     : REMark t4a
23090 :
23100 REMark data for cube vertices:
23110 REMark edge length of 2
23120 DATA 1,1,1          : REMark c1
23130 DATA 1,1,-1         : REMark c2
23140 DATA 1,-1,1         : REMark c3
23150 DATA 1,-1,-1        : REMark c4
23160 DATA -1,1,1         : REMark c5
23170 DATA -1,1,-1        : REMark c6
23180 DATA -1,-1,1        : REMark c7
23190 DATA -1,-1,-1       : REMark c8
23200 :
23210 REMark data for octahedron vertices:
23220 REMark edge length of sqrt(2)
23230 DATA 1,0,0          : REMark o1
23240 DATA -1,0,0         : REMark o2
23250 DATA 0,1,0          : REMark o3
23260 DATA 0,-1,0         : REMark o4
23270 DATA 0,0,1          : REMark o5
23280 DATA 0,0,-1         : REMark o6
23290 :
23300 REMark DATA for the 5 intersecting tetrahedra in a dodecahedron
23310 REMark 4 dodecahedron vertices for each of 5 tetrahedra
23320 DATA 1,6,12,15
23330 DATA 2,7,11,14
23340 DATA 3,8,9,17
23350 DATA 4,5,10,20
23360 DATA 13,16,18,19
23370 :
23380 REMark DATA for the other 5 intersecting tetrahedra in dodecahedron
23390 REMark with opposite 'handedness, chirality, enantiomorphy', etc.
23400 DATA 1,8,11,13
23410 DATA 2,5,12,16
23420 DATA 3,6,10,19
23430 DATA 4,7,9,18
23440 DATA 14,15,17,20
23450 :
23460 ::
23470 REMark x,y,z values for 2 sets of 5 intersecting tetrahedra
23480 REMark edge lengths of 2*sqrt(2) to match up with dodecahedron
23490 :
23500 REMark set 1 tetrahedron 1
23510 DATA itau, 0, tau   : REMark d1
23520 DATA 0, tau, -itau  : REMark d6
23530 DATA -tau, -itau, 0 : REMark d12
23540 DATA 1, -1, -1      : REMark d15
23550 :
23560 REMark set 1 tetrahedron 2
23570 DATA itau, 0, -tau  : REMark d2
23580 DATA 0, -tau, itau  : REMark d7
23590 DATA -tau, itau, 0  : REMark d11
23600 DATA 1, 1, 1        : REMark d14
23610 :
23620 REMark set 1 tetrahedron 3
23630 DATA -itau, 0, tau  : REMark d3
23640 DATA 0, -tau, -itau : REMark d8
23650 DATA tau, itau, 0   : REMark d9
23660 DATA -1, 1, -1      : REMark d17
23670 :
23680 REMark set 1 tetrahedron 4
23690 DATA -itau, 0, -tau : REMark d4
23700 DATA 0, tau, itau   : REMark d5
23710 DATA tau, -itau, 0  : REMark d10
23720 DATA -1, -1, 1      : REMark d20
23730 :
23740 REMark set 1 tetrahedron 5
23750 DATA 1, 1, -1       : REMark d13
23760 DATA 1, -1, 1       : REMark d16
23770 DATA -1, 1, 1       : REMark d18
23780 DATA -1, -1, -1     : REMark d19
23790 :
23800 :
23810 REMark set 2 tetrahedron 1
23820 DATA itau, 0, tau   : REMark d1
23830 DATA 0, -tau, -itau : REMark d8
23840 DATA -tau, itau, 0  : REMark d11
23850 DATA 1, 1, -1       : REMark d13
23860 :
23870 REMark set 2 tetrahedron 2
23880 DATA itau, 0, -tau  : REMark d2
23890 DATA 0, tau, itau   : REMark d5
23900 DATA -tau, -itau, 0 : REMark d12
23910 DATA 1, -1, 1       : REMark d16
23920 :
23930 REMark set 2 tetrahedron 3
23940 DATA -itau, 0, tau  : REMark d3
23950 DATA 0, tau, -itau  : REMark d6
23960 DATA tau, -itau, 0  : REMark d10
23970 DATA -1, -1, -1     : REMark d19
23980 :
23990 REMark set 2 tetrahedron 4
24000 DATA -itau, 0, -tau : REMark d4
24010 DATA 0, -tau, itau  : REMark d7
24020 DATA tau, itau, 0   : REMark d9
24030 DATA -1, 1, 1       : REMark d18
24040 :
24050 REMark set 2 tetrahedron 5
24060 DATA 1, 1, 1        : REMark d14
24070 DATA 1, -1, -1      : REMark d15
24080 DATA -1, 1, -1      : REMark d17
24090 DATA -1, -1, 1      : REMark d20
24100 :
24110 REMark DATA for the 5 intersecting tetrahedra in a dodecahedron
24120 REMark referenced to the dodecahedron vertices
24130 REMark 4 vertices for each of 5 tetrahedra
24140 DATA 1,6,12,15
24150 DATA 2,7,11,14
24160 DATA 3,8,9,17
24170 DATA 4,5,10,20
24180 DATA 13,16,18,19
24190 :
24200 REMark DATA for other 5 intersecting tetrahedra in dodecahedron
24210 REMark with opposite 'handedness, chirality, enantiomorphy', etc.
24220 REMark referenced to the dodecahedron vertices
24230 REMark 4 vertices for each of 5 tetrahedra
24240 DATA 1,8,11,13
24250 DATA 2,5,12,16
24260 DATA 3,6,10,19
24270 DATA 4,7,9,18
24280 DATA 14,15,17,20
24290 :
24300 REMark end of DATA section
24310 REMark ------------------------------------------------------------
24320 :
24330 REMark =============================================================
24340 :
24350 REMark Comments here for further programming ideas ?
24360 REMark data for buckyball (truncated icosahedron) ?
24370 REMark data for cuboctahedron ?
24380 REMark data for icosadodecahedron ?
24390 REMark other Archimedean Solids, Kepler-Poinsot,?
24400 REMark Petrie solids ? N dimensional ?
24410 :
24420 STOP
24430 :
24440 REMark
24450 REMark try the plane_frm3pts
24460 DIM try(3,3)
24470 :
24480 try(1,1)=0
24490 try(1,2)=0
24500 try(1,3)=2
24510 :
24520 try(2,1)=0
24530 try(2,2)=0
24540 try(2,3)=0
24550 :
24560 try(3,1)=0
24570 try(3,2)=1
24580 try(3,3)=0
24590 :
24600 Plane_frm3pts try
24610 :
24620 PRINT Ax,By,Cz,Dp
24630 PRINT cos_alpha,cos_beta,cos_gamma,omega
24640 PAUSE
24650 :
24660 REMark DATA for trials
24670 DATA 0,0,0,1,0,0,0,1,0
24680 DATA 1,0,0,0,1,0,0,0,1
24690 DATA 1,5,7,2,2,-1,-3,2,4
24700 DATA 1,-4,4,2,3,5,3,-2,0
24710 DATA 2,1,3,0,4,1,3,3,5
24720 DATA 2,1,3,0,4,1,3,3,5
24730 :
24740 DIM try(3,3)
24750 RESTORE 24660
24760 FOR rst = 17520 TO 17580 STEP 10
24770 RESTORE rst
24780 FOR i = 1 TO 3
24790  FOR j = 1 TO 3
24800  READ try(i,j) : PRINT try(i,j),
24810  END FOR j
24820 END FOR i
24830 PRINT
24840 Plane_frm3pts try
24850 PRINT Ax,By,Cz,Dp
24860 PRINT cos_alpha,cos_beta,cos_gamma,omega
24870 END FOR rst
24880 STOP
24890 :
24900 DEFine PROCedure see_inks
24910 REMark choose ink4 inks
24920 set_screen
24930 PAPER 0 : CLS
24940 FOR i = 0 TO 21
24950 INK ink4(i)
24960 LINE -2,(i/10)-2 TO 2,i/10
24970 END FOR i
24980 PAUSE
24990 CLS
25000 FOR i = 1 TO 21
25010 INK ink4(i)
25020 PRINT #0, i,ink4(i)
25030 CIRCLE 0,0,tau
25040 FILL 1
25050 CIRCLE 0,0,itau
25060 FILL 0
25070 PAUSE
25080 CLS #0 :CLS
25090 END FOR i
25100 INK 4
25110 END DEFine see_inks
25120 :
25130 DEFine PROCedure line_n3space (point_one,point_two)
25140 LOCal i
25150 REMark two points, x,y,z with direction being from 1 to 2
25160 DIM Al3s(2,3)
25170 FOR i = 1 TO 3
25180   Al3s(1,i) = point_one(i)
25190   Al3s(2,i) = point_two(i)
25200 END FOR i
25210 REMark where Al3s is a 2x3 matrix; 2 points and x,y,z values
25220 REMark assume direction is from point 1 to point 2
25230 REMark Al3s(0,0) will be distance between points
25240 REMark Al3s(0,[1,2,3]) will be direction cosines
25250 Al3s(0,0) = 0
25260 FOR i = 1 TO 3
25270   REMark get differences in x,y,z values
25280   Al3s(0,i) = Al3s(2,i)-Al3s(1,i)
25290   REMark sum the squares and store in Al3s(0,0)
25300   Al3s(0,0) = Al3s(0,0) + (Al3s(0,i) * Al3s(0,i))
25310   REMark PRINT i, Al3s(0,0)
25320 END FOR i
25330 REMark distance in space between points
25340 Al3s(0,0) = SQRT(Al3s(0,0))
25350 IF Al3s(0,0) = 0 : PRINT#0; "Line_N3space has no length !",point_one, point_two: PAUSE 30 : GO TO 25400 :REMark STOP
25360 FOR i = 1 TO 3
25370   REMark get direction cosines = unit vector values
25380   Al3s(0,i) = Al3s(0,i)/Al3s(0,0)
25390 END FOR i
25400 END DEFine line_n3space
25410 :
25420 REMark Platonic Solids Names  PS_name$(6,12)
25430 DATA "Tetrahedron","Cube","Octahedron","Dodecahedron","Icosahedron"
25440 REMark FIT
25450 DATA "Five I Tetra"
25460 :
25470 REMark number of Vertices, Edges, Faces, Schlafli symbol
25480 REMark PS_vefpq%(6,5)
25490 REMark Vertices, Edges, Faces, Edges/Face, Edges/Vertex
25500 REMark Schlfli {p,q} is {edges per face, edges per vertex}
25510 REMark  V,  E,  F, Schlfli{p,q}
25520 DATA    4,  6,  4,          3, 3
25530 DATA    8, 12,  6,          4, 3
25540 DATA    6, 12,  8,          3, 4
25550 DATA   20, 30, 12,          5, 3
25560 DATA   12, 30, 20,          3, 5
25570 REMark FIT
25580 DATA    4,  6,  4,          3, 3
25590 :
25600 REMark inner, mid, and outer radii for edge length of 2
25610 REMark as given in Coxeter
25620 REMark PS_radii(6,3)
25630 DATA 1/SQRT(6), 1/SQRT(2), SQRT(3)*(1/SQRT(2))
25640 DATA 1, SQRT(2), SQRT(3)
25650 DATA SQRT(2)*(1/SQRT(3)),1,SQRT(2)
25660 DATA (1/(SQRT(SQRT(5))))*tau^(5/2), tau*tau, tau*SQRT(3)
25670 DATA (1/SQRT(3))*tau*tau, tau, SQRT(tau)*SQRT(SQRT(5))
25680 REMark FIT
25690 DATA 1/SQRT(6), 1/SQRT(2), SQRT(3)*(1/SQRT(2))
25700 :
25710 REMark angular data
25720 REMark PS_angles(5,3)
25730 REMark 1 for phi, 2 for chi, 3 for psi, 0 for dihedral
25740 :
25750 DATA PI/2 - kappa
25760 DATA 2*kappa
25770 DATA PI/2 - kappa
25780 :
25790 DATA kappa
25800 DATA PI/2-kappa
25810 DATA PI/4
25820 :
25830 DATA PI/4
25840 DATA PI/2-kappa
25850 DATA kappa
25860 :
25870 DATA mu
25880 DATA PI/2 - lambda - mu
25890 DATA lambda
25900 :
25910 DATA lambda
25920 DATA PI/2 - lambda - mu
25930 DATA mu
25940 :
25950 REMark FIT
25960 DATA PI/2 - kappa
25970 DATA 2*kappa
25980 DATA PI/2 - kappa
25990 :
26000 REMark 10 FIT_colors
26010 REMark for outside of struts
26020 DATA 2,4,42,28,242
26030 REMark for inside
26040 DATA 234,220,47,31,50
26050 REMark 11 more colors
26060 DATA 18,36,248,55,52,7
26070 DATA 208,224,16,32,56
26080 :
26090 DEFine PROCedure adjust (edge_links, vert_ices)
26100 LOCal i,j
26110 REMark preserve called array by making a working array
26120 REMark e.g. edge_links = t_sev% , vert_ices = t_sv ,etc.
26130 DIM work_array(DIMN(vert_ices),xyz)
26140 FOR i = 0 TO DIMN(vert_ices)
26150   FOR j = 1 TO xyz
26160     work_array(i,j) = vert_ices(i,j)
26170   END FOR j
26180 END FOR i
26190 CLS
26200 CLS #0
26210 show_edges edge_links,work_array
26220 adj = 1
26230 in$ = ''
26240 REPeat ad_just
26250 CLS #0
26260 PRINT #0\" [x], [y], [z] or [X], [Y], [Z] to rotate by ";adj;""\"[m]ore or [less] or [M]ore or [L]ess degrees",,"[ESC] to exit"
26270 in$ = INKEY$(-1)
26280 IF in$="M":adj = adj * 2
26290 IF in$="m":adj = adj + 1
26300 IF ((in$="l")AND (adj > 1)) :adj = adj - 1
26310 IF in$="L" :adj = adj/2
26320 IF CODE(in$)=27 : EXIT ad_just
26330 IF CODE(in$)<95 : adjm = -adj
26340 IF CODE(in$)>95 : adjm = adj
26350 IF NOT(in$=='x' OR in$=='y' OR in$=='z') : NEXT ad_just
26360 rotate work_array,in$,adjm
26370 CLS
26380 show_edges edge_links,work_array
26390 END REPeat ad_just
26400 END DEFine adjust
26410 :
26420 REMark exercise for linesN3space
26430 INPUT "Point 1, Line 1, X value ?",P1L1X
26440 INPUT "Point 1, Line 1, Y value ?",P1L1Y
26450 INPUT "Point 1, Line 1, Z value ?",P1L1Z
26460 INPUT "Point 2, Line 1, X value ?",P2L1X
26470 INPUT "Point 2, Line 1, Y value ?",P2L1Y
26480 INPUT "Point 2, Line 1, Z value ?",P2L1Z
26490 INPUT "Point 1, Line 2, X value ?",P1L2X
26500 INPUT "Point 1, Line 2, Y value ?",P1L2Y
26510 INPUT "Point 1, Line 2, Z value ?",P1L2Z
26520 INPUT "Point 2, Line 2, X value ?",P2L2X
26530 INPUT "Point 2, Line 2, Y value ?",P2L2Y
26540 INPUT "Point 2, Line 2, Z value ?",P2L2Z
26550 linesN3space
26560 :
26570 DEFine PROCedure list_array (arrayname)
26580 LOCal i,j,k,l,m,n,o,p,q,r,index, line_count
26590 REMark what if an array has more than 10 dimensions ? !!
26600 INK 4
26610 :
26620 DIM indices(11)
26630 index = 0
26640 line_count = 0
26650 REPeat find_dimns
26660 index = index + 1
26670 indices(0)= indices(0) + 1
26680 indices(index) = DIMN(arrayname,index)
26690 IF NOT(indices(index)) : index = index -1 :EXIT find_dimns
26700 END REPeat find_dimns
26710 :
26720 PRINT " the array has ";index;" dimensions as follows "
26730 FOR i = 1 TO index : PRINT indices(i), : END FOR i
26740 PRINT \\'any key for contents of array '
26750 PAUSE
26760 CLS
26770 FOR i = 0 TO indices(1)
26780  IF index > 1 THEN
26790   FOR j = 0 TO indices(2)
26800  END IF
26810   IF index > 2 THEN
26820    FOR k = 0 TO indices(3)
26830   END IF
26840    IF index > 3 THEN
26850     FOR l = 0 TO indices(4)
26860    END IF
26870     IF index > 4 THEN
26880      FOR m = 0 TO indices(5)
26890     END IF
26900      IF index > 5 THEN
26910       FOR n = 0 TO indices(6)
26920      END IF
26930       IF index > 6 THEN
26940        FOR o = 0 TO indices(7)
26950       END IF
26960        IF index > 7 THEN
26970         FOR p = 0 TO indices(8)
26980        END IF
26990         IF index > 8 THEN
27000          FOR q = 0 TO indices(9)
27010         END IF
27020          IF index > 9 THEN
27030           FOR r = 0 TO indices(10)
27040          END IF
27050 IF index > 10 : PRINT "Too many dimensions ! - rewrite program !" :STOP
27060 :
27070 IF index=10 : PRINT i!j!k!l!m!n!o!p!q!r,"=", arrayname(i,j,k,l,m,n,o,p,q,r)
27080 IF index=9 : PRINT i!j!k!l!m!n!o!p!q,"=", arrayname(i,j,k,l,m,n,o,p,q)
27090 IF index=8 : PRINT i!!!j!!!k!!!l!!!m!!!n!!!o!!!p,"=", arrayname(i,j,k,l,m,n,o,p)
27100 IF index=7 : PRINT i!!!j!!!k!!!l!!!m!!!n!!!o,"=", arrayname(i,j,k,l,m,n,o)
27110 IF index=6 : PRINT i!!!j!!!k!!!l!!!m!!!n,"=", arrayname(i,j,k,l,m,n)
27120 IF index=5 : PRINT i!!!j!!!k!!!l!!!m,"=", arrayname(i,j,k,l,m)
27130 IF index=4 : PRINT i!!!j!!!k!!!l,"=", arrayname(i,j,k,l)
27140 IF index=3 : PRINT i!!!j!!!k,"=", arrayname(i,j,k)
27150 IF index=2 : PRINT i!!!j,"=", arrayname(i,j)
27160 IF index=1 : PRINT i,"=", arrayname(i)
27170 line_count = line_count + 1
27180 IF line_count = 20 : PAUSE :line_count = 0
27190 IF index > 9 : END FOR r
27200 IF index > 8 : END FOR q
27210 IF index > 7 : END FOR p
27220 IF index > 6 : END FOR o
27230 IF index > 5 : END FOR n
27240 IF index > 4 : END FOR m
27250 IF index > 3 : END FOR l
27260 IF index > 2 : END FOR k
27270 IF index > 1 : END FOR j
27280 PRINT
27290 line_count = line_count + 1
27300 IF line_count = 20 : PAUSE :line_count = 0
27310 END FOR i
27320 END DEFine list_array
27330 :
27340 REMark End of PROC and FuN 's ??
27350 :
27360 REMark OUTLINE of this program : RESTORES refer to line numbers
27370 RESTORE 27360 : RESTORE 28160   : REMark this outline
27380 RESTORE 28170 : RESTORE 28200  : REMark references
27390 RESTORE 28200 : RESTORE 28800 : REMark constants and variables
27400 :
27410 RESTORE 400 : RESTORE 660 : REMark PROC set_screen
27420 RESTORE 300 : RESTORE 380 : REMark PROC build_solids
27430 RESTORE 680 : RESTORE 1350 : REMark PROC set_constants
27440 RESTORE 1370 : RESTORE 2220 : REMark PROC build_tetrahedron
27450 RESTORE 2240 : RESTORE 2520 : REMark PROC turn_polyz
27460 RESTORE 2540 : RESTORE 2820 : REMark PROC poly_copy
27470 RESTORE 2540 : RESTORE 2820 : REMark PROC center_bounds
27480 RESTORE 3150 : RESTORE 3180 : REMark PROC zorder
27490 RESTORE 3200 : RESTORE 3360 : REMark PROC show_polyz
27500 RESTORE 3380 : RESTORE 3460 : REMark PROC sliceout_tp
27510 RESTORE 3480 : RESTORE 3550 : REMark PROC slicein_tp
27520 RESTORE 3580 : RESTORE 3820 : REMark PROC show_polys
27530 RESTORE 3840 : RESTORE 4930 : REMark PROC make_polys
27540 RESTORE 4950 : RESTORE 6290 : REMark PROC order_ve
27550 RESTORE 6310 : RESTORE 6340 : REMark FuN s_to_p
27560 RESTORE 6360 : RESTORE 6420 : REMark FuN p_to_s
27570 RESTORE 6470 : RESTORE 7020 : REMark PROC build_cube
27580 RESTORE 7040 : RESTORE 7600 : REMark PROC build_octahedron
27590 RESTORE 7620 : RESTORE 8140 : REMark PROC build_dodecahedron
27600 RESTORE 8160 : RESTORE 8660 : REMark PROC build_icosahedron
27610 RESTORE 8690 : RESTORE 11400 : REMark PROC build_FIT 2 sets FIT
27620 REMark build two sets of five intersecting tetrahedra
27630 :
27640 RESTORE 11500 : RESTORE 11630 : REMark PROC show_angles
27650 RESTORE 11650 : RESTORE 11750 : REMark PROC show_vertices
27660 RESTORE 11810 : RESTORE 11930 : REMark PROC show_edges
27670 RESTORE 12950 : RESTORE 13100 : REMark FuN space_btwn
27680 RESTORE 13140 : RESTORE 13250 : REMark FuN dist_btwn
27690 RESTORE 13280 : RESTORE 13580 : REMark FuN angl_frm
27700 RESTORE 13600 : RESTORE 13830 : REMark PROC rotate
27710 RESTORE 13850 : RESTORE 14790 : REMark PROC linesN3space
27720 RESTORE 14810 : RESTORE 15670 : REMark PROC Plane_frm3pts
27730 RESTORE 15690 : RESTORE 15890 : REMark PROC parameterize
27740 RESTORE 15910 : RESTORE 16050 : REMark PROC review_L3S
27750 RESTORE 16070 : RESTORE 16130 : REMark PROC swap
27760 RESTORE 16150 : RESTORE 16210 : REMark FuN cyc
27770 RESTORE 16230 : RESTORE 16350 : REMark FuN DMS
27780 RESTORE 16370 : RESTORE 16420 : REMark PROC show_DMS
27790 RESTORE 16440 : RESTORE 16480 : REMark Fun SGN
27800 RESTORE 16500 : RESTORE 16610 : REMark FuN Pt_to_plane
27810 RESTORE 16630 : RESTORE 16730 : REMark PROC get_vertices
27820 RESTORE 16740 : RESTORE 16910 : REMark PROC get_edges
27830 RESTORE 16930 : RESTORE 17050 : REMark PROC get_vertex_to_edges
27840 RESTORE 17070 : RESTORE 19800 : REMark PROC get_faces
27850 RESTORE 19810 : RESTORE 20650 : REMark PROC review_links
27860 RESTORE 20670 : RESTORE 20770 : REMark PROC show_face
27870 RESTORE 20790 : RESTORE 20980 : REMark REMARKED PROC make_struts ?
27880 RESTORE 21000 : RESTORE 21120 : REMark PROC get_PS_nums
27890 RESTORE 21150 : RESTORE 21430 : REMark PROC revolve
27900 RESTORE 21450 : RESTORE 22410 : REMark PROC make_struts
27910 RESTORE 22430 : RESTORE 22490 : REMark FuN interp
27920 RESTORE 22560 : RESTORE 24310 : REMark DATA statements
27930 RESTORE 22590 : REMark DATA dodeca
27940 RESTORE 22820 : REMark DATA icosa
27950 RESTORE 22970 : REMark DATA tetra
27960 RESTORE 23040 : REMark DATA alternate tetra
27970 RESTORE 23100 : REMark DATA cube
27980 RESTORE 23210 : REMark DATA octa
27990 RESTORE 23300 : REMark DATA one set of five intersecting tetra
28000 RESTORE 23380 : REMark DATA other set of five intersecting tetra
28010 RESTORE 23470 : REMark DATA two sets of 5 intersecting tetra
28020 RESTORE 24330 : RESTORE 24420 : REMark comments for future projects
28030 RESTORE 24440 : RESTORE 24950 : REMark tryout area scratch pad
28040 RESTORE 24660 : REMark DATA for try
28050 RESTORE 24740 : RESTORE 24880 : REMark try
28060 RESTORE 24900 : RESTORE 25110 : REMark see_inks
28070 RESTORE 25130 : RESTORE 25400 : REMark PROC line_n3space
28080 RESTORE 25420 : REMark DATA name$
28090 RESTORE 25470 : REMark DATA PS_vefpq%
28100 RESTORE 25600 : REMark DATA radii
28110 RESTORE 25710 : REMark DATA angles
28120 RESTORE 26000 : REMark DATA ink color sets
28130 RESTORE 26090 : RESTORE 26400 : REMark PROC adjust
28140 RESTORE 26420 : RESTORE 26550 : REMark trial for linesN3space
28150 RESTORE 26570 : RESTORE 27320 : REMark PROC list_array
28160 :
28170 REMark Ref: "Regular Polytopes" by H.S.M. Coxeter
28180 REMark Dover edition 1973 ISBN 0-486-61480-8
28190 REMark pages 52-53 and Table 1 page 292-3
28200 :
28210 REMark Tetrahedron, Cube, Octahedron, Dodecahedron, Icosahedron
28220 REMark Vertices, Edges, Faces, Schlfli symbol
28230 REMark Equations of lines, planes
28240 REMark Do rotation, scaling, translation
28250 REMark initial coordinates of vertices as DATA statements
28260 REMark location as in RESTORE following DIM
28270 REMark use arrays t_v, c_v, o_v, d_v, i_v for vertices
28280 REMark (v#, [1,2,3] for x,y,z values
28290 REMark use arrays t_ev%, c_ev%, o_ev% ,d_ev% ,i_ev% for
28300 REMark                        edges to vertices links
28310 REMark (e#, [v1,v2])  General call as eva
28320 REMark use arrays t_fv%, c_fv%, o_fv%, d_fv%, i_fv% for
28330 REMark                        face to vertices links
28340 REMark (f#,[v1,v2,...vN]) {ordered set}  General call as fva
28350 REMark use arrays t_fe%, c_fe%, o_fe%, d_fe%, i_fe% for
28360 REMark                        face to edge links
28370 REMark (f#,[e1,e2,...eN])  General call as fea
28380 REMark use arrays t_ve%, c_ve%, o_ve%, d_ve%, i_ve% for
28390 REMark                        vertex to edge links
28400 REMark (#v,[e1,e2,...eN])  General call as vea
28410 REMark use arrays t_ef%, c_ef%, o_ef%, d_ef%, i_ef% for
28420 REMark                        edge to face links
28430 REMark (#e,[f1,f2])   General call as efa
28440 REMark use arrays t_vf%, c_vf%, o_vf%, d_vf%, i_vf% for
28450 REMark                        vertex to face links
28460 REMark (v,[f1,f2,..fN]) General call as vfa
28470 REMark use arrays t_fq, c_fq, o_fq, d_fq, i_fq for
28480 REMark                        equation of planes for faces
28490 REMark 0,1,2,3 normal form;
28500 REMark 4,5,6,7 linear form;
28510 REMark 8,9,10 for xyz of center
28520 REMark of the face (f,[10])
28530 REMark t_sv, etc. for strut vertices
28540 REMark t_sev%, etc. for strut edge to vertices link
28550 REMark ts_ze%, etc. for trapezoid to edges link
28560 REMark PS_radii(n,[1, 2, 3]) 1=inner, 2=mid, 3=circumscribing
28570 REMark use variables tl,cl,ol,dl,il for edge length
28580 REMark or PS_radii(n,0)
28590 REMark higher values for spherical angles, area, volume etc. ?
28600 REMark PS_angles(5,3) dihedral and spherical ?
28610 :
28620 REMark pertinent values for Vertices, Edges, Faces, Schlafli symbol
28630 REMark Vertices, Edges, Faces, Edges/Face, Edges/Vertex
28640 REMark Schlfli {p,q} is {edges(and vertices) per face, edges per vertex}
28650 :
28660 REMark Platonic Solid  V       E       F    Schlfli{p,q}
28670 REMark Tetrahedron     4       6       4    {3,3}
28680 REMark Cube            8       12      6    {4,3}
28690 REMark Octahedron      6       12      8    {3,4}
28700 REMark Dodecahedron    20      30      12   {5,3}
28710 REMark Icosahedron     12      30      20   {3,5}
28720 REMark PS_vefpq%(PS,    1       2       3    4 5   )
28730 :
28740 DEFine PROCedure show_inks
28750 CSIZE 3,1 : PAPER 0: INK 4 : CLS
28760 PRINT, "(ink4) assignments"\
28770 FOR i = 1 TO DIMN(ink4)
28780 AT 2+((i-1) DIV 3), 11*((i-1) MOD 3):PRINT;'#';i;'=';ink4(i);
28790 PAPER ink4(i)
28800 PRINT'    ';
28810 INK 4
28820 PAPER 0
28830 PRINT ' ';
28840 END FOR i
28850 PAUSE
28860 CSIZE 0,0 :PAPER 0: INK 4 : CLS
28870 END DEFine show_inks
28880 REMark last line  ?
