100 REMark PerimEllipApprox_bas
110 REMark HL Schaaf Oct 7, 1998
120 REMark perimeter of ellipse by various approximations
130 REMark compared with 'exact'  AGM solution
140 :
150 REMark Peano 1,2,&3, Ramanujan 1,2,&3, Goormaghtigh, Nyvoll
160 REMark as FuNctions (a,b)
170 REMark a = semi-major axis and b = semi-minor axis
180 REMark return total perimeter = 4 * elliptic integral of 2nd kind
190 REMark multiply AGM  by  4 to  make comparisons
200 :
210 WTV : MODE 4 : WINDOW 512, 256, 0, 0 : PAPER 0 : INK 6 : CSIZE 1, 0
220 :
230 REPeat  compare_approxs
240 a = 1
250 CLS #0  : CLS
260 REPeat  get_b
270 INPUT 'b from 0 to  1  ? ';b
280 IF (b>=0  AND b<=1) : CLS : EXIT  get_b
290 PRINT 'value out of range ! ( 0  to  1 )'
300 END REPeat get_b
310 k  =  SQRT(1-b*b)
320 CLS
330 PRINT 'a  = ';a, 'b =  '; b, 'k  = ';k
340 PRINT \'AGM  method'\,4*AGM_ellipint2(k)
350 PRINT \'Peano methods'\,Peano1(a,b)\,Peano2(a,b)\,Peano3(a,b)
360 PRINT \'Ramanujan methods'\,Raman1(a,b)\,Raman2(a,b)\,Raman3(a,b)
370 PRINT \'Goormaghtigh'\,Goor(a,b)
380 PRINT \'Nyvoll'\,Nyvoll(a,b)
390 PRINT #0;'[space  bar] for  another, [ESC]  to  exit'
400 IF CODE(INKEY$(-1))=27: CLS#0: EXIT  compare_approxs
410 END  REPeat  compare_approxs
420 :
430 DEFine FuNction Peano1(a,b)
440 RETurn PI*(a+b+((SQRT(a)-SQRT(b))^2)/2)
450 END DEFine Peano1
460 :
470 DEFine FuNction Peano2(a,b)
480 RETurn PI*((3/2)*(a+b) - SQRT(a*b))
490 END DEFine Peano2
500 :
510 DEFine FuNction Peano3(a,b)
520 LOCal s, p2
530 s=(a+b)/2 : p2=a*b
540 RETurn (PI*2/9)*(19*s-4*((2*s*s+3*p2)/SQRT(s*s+3*p2)))
550 END DEFine Peano3
560 :
570 DEFine FuNction Raman1(a,b)
580 RETurn PI*((3*(a+b))-(SQRT((a+(3*b))*((3*a)+b))))
590 END DEFine Raman1
600 :
610 DEFine FuNction Raman2(a,b)
620 RETurn PI*(a+b+(3*((a-b)^2)/((10*(a+b))+SQRT(a*a+14*a*b+b*b))))
630 END DEFine Raman2
640 :
650 DEFine FuNction Raman3(a,b)
660 LOCal t
670 t = ((a-b)/(a+b))^2
680 RETurn PI*((a+b)*(1+(3*t)/(10 + (SQRT(4-(3*t))))))
690 END DEFine Raman3
700 :
710 DEFine FuNction Goor(a,b)
720 RETurn PI*((9/8)*(a+b)-(5/8)*SQRT(a*b)+(3/8)*SQRT((a*a+b*b)/2))
730 END DEFine Goor
740 :
750 DEFine FuNction Nyvoll(a,b)
760 LOCal t
770 t = ((a-b)/(a+b))^2
780 RETurn PI*(a+b)*(1+(t/8))^2
790 END DEFine Nyvoll
800 :
810 DEFine FuNction AGM_ellipint2(k)
820 LOCal i, k_comp, nth
830 REMark solves F(k) = complete elliptic integral of first kind
840 REMark RETurns E(k) = complete elliptic integral of second kind
850 REMark k is the eccentricity of the ellipse
860 IF k<0 OR k>1 : PRINT #0;k;' is out of range (0 to 1)':STOP
870 k_comp = SQRT(1-k*k)
880 DIM iter(3,1)
890 iter(1,0) = 1
900 iter(2,0) = k_comp
910 iter(3,0) = k
920 sum_of_terms = (2^-1)*(k*k)
930 nth = 0
940 REPeat converge
950  iter(1,1) = (iter(1,0)+iter(2,0))/2
960  iter(2,1) = SQRT((iter(1,0)*iter(2,0)))
970  iter(3,1) = iter(1,0)-iter(1,1)
980  sum_of_terms = sum_of_terms + 2^(nth)*(iter(3,1)*(iter(3,1)))
990  nth = nth + 1
1000  FOR i = 1 TO 3
1010   iter(i,0)=iter(i,1)
1020  END FOR i
1030  IF ( iter(3,0) < 1E-10 ) : EXIT converge
1040 END REPeat converge
1050 REMark ratio of second kind to first kind
1060 sec_to_first = 1 - sum_of_terms
1070 K_k = PI/(2*iter(1,1))
1080 E_k = K_k * sec_to_first
1090 IF k = 1 THEN
1100  REMark K_k is actually infinity
1110  K_k = 9.9E615 : E_k = 1
1120 END IF
1130 REMark RETurn K_k
1140 RETurn E_k
1150 END DEFine AGM_ellipint2
1160 :
1170 REMark  end of listing PerimEllipApprox_bas
