100 REMark where_phi_bas
110 REMark H L Schaaf Oct 6, 1998
120 REMark to go with Gee Graphics #7
130 :
140 WTV : WINDOW 512, 256, 0, 0 : PAPER 0 : INK 4
150 SCALE 2, -1.2, -.8 : CSIZE 1,0 : CLS
160 :
170 a = 1  : REMark keep semi-major axis = a = 1
180 REMark  b = semi-minor axis; any value >0 AND <1
190 b = .5
200 k = SQRT(1-b*b)  : REMark k is eccentricity of ellipse
210 :
220 REPeat  showhere
230 INK 4
240 CLS
250 AT 1, 2 : PRINT 'a = ';a, 'b = ';b, 'k = ';k
260 CIRCLE  0, 0, 1
270 ELLIPSE 0, 0, b, 1/b, 0
280 LINE 0, 0 TO a, 0
290 LINE 0, 0 TO 0, b
300 CURSOR 0, 0, -8, -4 : PRINT 'O'
310 CURSOR a, 0,  5, -4 : PRINT 'A'
320 CURSOR 0, b, -8, -8 : PRINT 'B'
330 REMark show one foci of ellipse
340 LINE k, 2E-2 TO k, -2E-2
350 CURSOR k, 0, 0, 2 :PRINT 'F'
360 REPeat get_phi
370  AT 3, 2 : PRINT '               '
380  INK  6 : AT 2, 2 : INPUT 'phi ( 0'&CHR$(186)&' to 90'&CHR$(186)&' ) ? '\'  ';phi;CHR$(186);
390  IF  phi >= 0  AND  phi <= 90  : EXIT get_phi
400  AT 4, 2 : PRINT "? range ? 0 to 90 ?"
410 END REPeat get_phi
420 AT 4, 2 : PRINT "Angle BOQ = ";phi;CHR$(186);'       '
430 E_k_phi = ELIT2(k,phi)
440 AT 5, 2 : PRINT "length of arc BP = ";E_k_phi
450 REMark find x  and y coordinates of Q on circle
460 QX = COS(RAD(90-phi))
470 Qy = SIN(RAD(90-phi))
480 LINE  0, 0  TO QX, Qy
490 CURSOR QX, Qy, -4, -12 : PRINT "Q"
500 Px = QX
510 REMark find y coordinate of P on ellipse
520 REMark  ((x^2)/(a^2)) + ((y^2)/(b^2))  =  1
530 Py = SQRT(ABS(1-(Px^2))*(b^2))
540 LINE QX, Qy TO Px, Py
550 CURSOR Px, Py, -4, 8 : PRINT 'P'
560 IF Py THEN
570  BOP = DEG(ATAN(Px/Py))
580 ELSE
590  BOP = 90
600 END IF
610 AT 6, 2 : PRINT "Angle BOP = ";BOP;CHR$(186)
620 LINE 0, 0  TO Px, Py
630 INK #0, 4
640 PRINT #0; "[space bar] for another phi, [ESC] to quit"
650 INK  2
660 CIRCLE QX, Qy, 1E-2 ; Px, Py, 1E-2 ; 0, 0, 1E-2 ; 0, b, 1E-2
670 IF CODE(INKEY$(-1))=27 : INK#0,4 : EXIT showhere
680 END  REPeat showhere
690 :
700 DEFine FuNction ELIT2(k,phi)
710 LOCal a, b, c, g, r, a0, b0, d0
720 REMark ELIT2 RETurns elliptical integral of second kind
730 REMark k is eccentricity, phi is in degrees
740 g = 0 : r = k * k : a0 = 1 : b0 = SQRT(1 - r) : d0 = RAD(phi)
750 IF k=1 AND phi = 90 THEN
760   FE=1E300 : EE = 1 : GO TO 1070
770 ELSE
780  IF k = 1 THEN
790    FE = LN(( 1 +SIN(d0))/COS(d0))
800    EE = SIN(d0) : GO TO 1070
810  ELSE
820    fac = 1
830    REPeat loop
840     a = (a0+b0)/2
850     b = SQRT(a0*b0)
860     c = (a0-b0)/2
870     fac = 2*fac
880     r = r + fac * c * c
890     IF (phi<>90) THEN
900       d = d0 + ATAN((b0/a0)*TAN(d0))
910       g = g + c * SIN(d)
920       d0 = d + PI*INT(d/PI+.5)
930     END IF
940     a0 = a : b0 = b
950     IF (c<1E-8): EXIT loop
960   END REPeat loop
970   ck=PI/(2*a)
980   ce=PI*(2 - r)/(4*a)
990   IF (phi = 90) THEN
1000     FE = ck : EE = ce
1010   ELSE
1020     FE = d/(fac * a)
1030     EE = FE * ce/ck + g
1040   END IF
1050  END IF
1060 END IF
1070 REMark RETurn FE
1080 RETurn EE
1090 END DEFine ELIT
1100 :
1110 REMark end of listing for where_phi_bas
